declare namespace FC {
	namespace Facilities {
		export type Facility = InstanceType<typeof App.Entity.Facilities.Facility>;
		export type Animal = InstanceType<typeof App.Entity.Animal>;

		interface Pit {
			/** Defaults to "the Pit" if not otherwise set. */
			name: string;

			/** Has a slave fight an animal if not null. */
			animal: Animal;
			/** The type of audience the Pit has. */
			audience: "none" | "free" | "paid";
			/** Whether or not the bodyguard is fighting this week. */
			bodyguardFights: boolean;
			/** An array of the IDs of slaves assigned to the Pit. */
			fighterIDs: number[];
			/** Whether or not a fight has taken place during the week. */
			fought: boolean;
			/** Whether or not the fights in the Pit are lethal. */
			lethal: boolean;
			/** The ID of the slave fighting the bodyguard for their life. */
			slaveFightingBodyguard: number;
			/** The virginities of the loser not allowed to be taken. */
			virginities: "neither" | "vaginal" | "anal" | "all"
		}
	}
}
