App.SecExp.generator = (function() {
	return {
		attack,
		rebellion,
	};

	function shared() {
		V.SecExp.war = V.SecExp.war || {};
		V.SecExp.war.commander = "assistant";
		V.SecExp.war.losses = 0;
		V.SecExp.war.attacker = {losses: 0};
	}

	function attack() {
		let attackChance = 0; // attackChance value is the chance out of 100 of an attack happening this week
		// attacks are deactivated if the arcology is in the middle of the ocean, security drones are not around yet, there is not a rebellion this week or the last attack/rebellion happened within 3 weeks
		if (V.terrain !== "oceanic" && V.arcologyUpgrade.drones === 1 && V.citizenRebellion === 0 && V.slaveRebellion === 0 && V.SecExp.battles.lastEncounterWeeks > 3 && V.SecExp.rebellions.lastEncounterWeeks > 3) {
			if (V.week < 30) {
				attackChance = 5;
			} else if (V.week < 60) {
				attackChance = 8;
			} else if (V.week < 90) {
				attackChance = 12;
			} else if (V.week < 120) {
				attackChance = 16;
			} else {
				attackChance = 20;
			}
			if (V.SecExp.battles.victories + V.SecExp.battles.losses >= 0) {
				attackChance = 25;
			}

			if (V.SecExp.battles.lastEncounterWeeks >= 10) {
				attackChance += V.SecExp.battles.lastEncounterWeeks/2; // attackChance += 5;
			}
			/* if (V.terrain === "oceanic") {
				attackChance -= 10;
			} */
			attackChance *= V.SecExp.settings.battle.frequency; // battle frequency
		}

		if (V.SecExp.settings.battle.force === 1 && V.SecExp.settings.rebellion.force === 0) {
			attackChance = 100;
		}

		if (random(1, 100) > attackChance) { // Rolls to see if attack happens this week
			V.SecExp.battles.lastEncounterWeeks++;
		} else {
			let type, terrain, troops, equip = 0, L = 0;
			V.attackThisWeek = 1;
			V.SecExp.battles.lastEncounterWeeks = 0;
			let raider = 25, oldWorld = 25, freeCity = 25, free = 25; // type is the chance out of 100 of an attack of that type happening
			// the old world attracted by "degenerate" future societies
			const setA = [
				'FSRomanRevivalist', 'FSEdoRevivalist', 'FSArabianRevivalist',
				'FSChineseRevivalist', 'FSEgyptianRevivalist', 'FSAztecRevivalist'];
			const setB = [
				'FSRepopulationFocus', 'FSGenderRadicalist', 'FSPastoralist',
				'FSChattelReligionist', 'FSNeoImperialist'];
			const resultA = setA.some((FS) => V.arcologies[0][FS] !== "unset");
			const resultB = setB.some((FS) => V.arcologies[0][FS] !== "unset");
			if (resultA && resultB) {
				oldWorld += 15;
				raider -= 5;
				freeCity -= 5;
				free -= 5;
			} else if (resultA || resultB) {
				oldWorld += 24;
				raider -= 8;
				freeCity -= 8;
				free -= 8;
			}
			// freedom fighters attracted by high slave/citizen ratio
			if (V.ASlaves > V.ACitizens * 2) {
				oldWorld -= 8;
				raider -= 8;
				freeCity -= 8;
				free += 24;
			} else if (V.ASlaves > V.ACitizens * 1.2 || V.arcologies[0].FSDegradationist !== "unset") {
				oldWorld -= 5;
				raider -= 5;
				freeCity -= 5;
				free += 15;
			}
			// free Cities attracted by high prosperity
			if (V.arcologies[0].prosperity >= 10 && V.arcologies[0].prosperity < 20) {
				oldWorld -= 5;
				raider -= 5;
				freeCity += 15;
				free -= 5;
			} else if (V.arcologies[0].prosperity >= 20) {
				oldWorld -= 8;
				raider -= 8;
				freeCity += 24;
				free -= 8;
			}
			// raiders are attracted by low security
			if (V.SecExp.core.security <= 50) {
				oldWorld -= 5;
				raider += 15;
				freeCity -= 5;
				free -= 5;
			} else if (V.SecExp.core.security <= 25) {
				oldWorld -= 8;
				raider += 24;
				freeCity -= 8;
				free -= 8;
			}

			const roll = random(1, 100); // makes the actual roll
			if (roll <= raider) {
				type = "raiders";
				troops = random(40, 80); L = 1;
			} else if (roll <= raider + oldWorld) {
				type = "old world";
				troops = random(25, 50);
			} else if (roll <= raider + oldWorld + freeCity) {
				type = "free city";
				troops = random(20, 40);
			} else if (roll <= raider + oldWorld + freeCity + free) {
				type = "freedom fighters";
				troops = random(30, 60);
			}

			if (V.terrain === "urban") {
				terrain = either("outskirts", "urban", "wasteland");
			} else if (V.terrain === "rural") {
				terrain = either("hills", "outskirts", "rural", "wasteland");
			} else if (V.terrain === "ravine") {
				terrain = either("hills", "mountains", "outskirts", "wasteland");
			} else if (V.terrain === "marine") {
				terrain = either("coast", "hills", "outskirts", "wasteland");
			// } else if (V.terrain === "oceanic") {
				// terrain = either("international waters", "an underwater cave", "a sunken ship", "an island");
			} else {
				terrain = "error";
			}

			if (V.week < 30) {
				troops *= random(1, 2); // troops *= Math.trunc(random( (1*(1.01+(V.week/100))), (2*(1.01+(V.week/100))) ))) {
			}
			if (V.week < 60) {
				troops *= random(1, 3); // troops *= Math.trunc(random( (1*(1.01+(V.week/200))), (3*(1.01+(V.week/200))) ))) {
				equip = random(0, 1);
			} else if (V.week < 90) {
				troops *= random(2, 3); // troops *= Math.trunc(random( (2*(1.01+(V.week/300))), (3*(1.01+(V.week/300))) ))) {
				equip = random(0, 3-L); // "raiders" equip = random(0,2)) {
			} else if (V.week < 120) {
				troops *= random(2, 4); // troops *= Math.trunc(random( (2*(1.01+(V.week/400))), (4*(1.01+(V.week/400))) ))) {
				equip = random(1-L, 3); // "raiders" equip = random(0,3)) {
			} else {
				troops *= random(3, 5);
				equip = random(2-L, 4-L); // "raiders" equip = random(1,3)) {
			}

			if (V.SecExp.settings.battle.major.enabled === 1) { // major battles have a 50% chance of firing after week 120
				if ((V.week >= 120 && random(1, 100) >= 50) || V.SecExp.settings.battle.major.force === 1) {
					V.majorBattle = 1;
					const sfActive = V.SF.Toggle && V.SF.Active >= 1;
					troops *= sfActive ? random(4, 6) : random(2, 3);
					equip = sfActive ? either(3, 4) : either(2, 3, 4);
				}
			}

			shared();
			V.SecExp.war.attacker.troops = troops;
			V.SecExp.war.attacker.equip = equip;
			V.SecExp.war.attacker.type = type;
			V.SecExp.war.terrain = terrain;
			V.SecExp.war.deploySF = 0;
			V.SecExp.war.saveValid = 0;
			V.SecExp.war.tacticsSuccessful = 0;
			V.SecExp.war.chosenTactic = either("Bait and Bleed", "Blitzkrieg", "Choke Points", "Defense In Depth", "Guerrilla", "Human Wave", "Interior Lines", "Pincer Maneuver");
			V.SecExp.war.estimatedMen = normalRandInt(troops, troops * (4 - App.SecExp.battle.recon()) * 0.05);
			V.SecExp.war.expectedEquip = normalRandInt(equip, (4 - App.SecExp.battle.recon()) * 0.25);
		}
	}

	function rebellion() {
		let type;
		if (V.SecExp.rebellions.slaveProgress >= 100) {
			if (random(1, 100) <= 80) {	// 80% of firing a rebellion once progress is at 100
				type = V.slaveRebellion = 1;
				V.SecExp.rebellions.slaveProgress = 0;
				V.SecExp.rebellions.citizenProgress *= 0.2;
			} else {
				V.SecExp.rebellions.slaveProgress = 100;
			}
		} else if (V.SecExp.rebellions.citizenProgress >= 100) {
			if (random(1, 100) <= 80) {
				type = V.citizenRebellion = 1;
				V.SecExp.rebellions.citizenProgress = 0;
				V.SecExp.rebellions.slaveProgress *= 0.2;
			} else {
				V.SecExp.rebellions.citizenProgress = 100;
			}
		}

		if (V.SecExp.settings.rebellion.force === 1 && V.foughtThisWeek === 0) {
			type = random(1, 100) <= 50 ? V.slaveRebellion = 1 : V.citizenRebellion = 1;
		}

		if (!type) {
			V.SecExp.rebellions.lastEncounterWeeks++;
		} else {
			const isSlaveRebellion = V.slaveRebellion === 1;
			let weekMod;
			if (V.week <= 30) {
				weekMod = 0.75 + (0.01+(V.week/200));
			} else if (V.week <= 60) {
				weekMod = 1 + (0.01+(V.week/300));
			} else if (V.week <= 90) {
				weekMod = 1.25 + (0.01+(V.week/400));
			} else if (V.week <= 120) {
				weekMod = 1.50 + (0.01+(V.week/500));
			} else {
				weekMod = 1.75;
			}

			shared();
			V.SecExp.rebellions.lastEncounterWeeks = 0;
			const authFactor = Math.clamp(1 - (V.SecExp.core.authority / 20000), 0.4, 0.6);
			const repFactor = Math.clamp(V.rep / 20000, 0.4, 0.6);
			const rebelPercent = 0.3 * authFactor;
			const irregularPercent = 0.2 * repFactor;

			const isDisloyal = (x) => (x < 10 && jsRandom(1, 100) <= 70) || (x < 33 && jsRandom(1, 100) <= 30) || (x < 66 && jsRandom(1, 100) <= 10);
			const baseValue = Math.trunc((isSlaveRebellion ? V.ASlaves : V.ACitizens) * rebelPercent * weekMod) + random(-100, 100);
			const highestValue = isSlaveRebellion ? V.ASlaves : V.ACitizens;
			V.SecExp.war.attacker.troops = Math.clamp(baseValue, 50, highestValue);
			V.SecExp.war.attacker.equip = Math.clamp(V.SecExp.edicts.weaponsLaw + random((isSlaveRebellion ? -2 : -1), 1), 0, 4);
			V.SecExp.war.irregulars = Math.clamp(Math.trunc(V.ACitizens * irregularPercent * weekMod) + random(-100, 100), 50, V.ACitizens);
			V.SecExp.war.engageRule = 0;
			V.SecExp.war.rebellingID = [].concat(App.SecExp.unit.humanSquads().map(u => u.loyalty).filter(isDisloyal));
		}
	}
})();

/**
 * Returns the effect (if any) the Special Force provides.
 * @param {string} [report] which report is this function being called from.
 * @param {string} [section=''] which sub section (if any) is this function being called from.
 * @returns {{text:string, bonus:number}}
 */
App.SecExp.assistanceSF = function(report, section = '') {
	const size = V.SF.Toggle && V.SF.Active >= 1 ? App.SF.upgrades.total() : 0;
	let r = ``, bonus = 0;
	if (size > 10) {
		if (report === 'authority' || report === 'trade') {
			r += `Having a powerful special force increases ${report === 'authority' ? 'your authority' : 'trade security'}.`;
			bonus += size / 10;
		} else if (report === 'security') {
			r += `Having a powerful special force attracts a lot of ${section === 'militia' ? 'citizens' : 'mercenaries'}, hopeful that they may be able to fight along side it.`;
			if (section === 'militia') {
				bonus *= 1 + (random(1, (Math.round(size / 10))) / 20); // not sure how high size goes, so I hope this makes sense
			} else if (section === 'mercs') {
				bonus += random(1, Math.round(size / 10));
			}
		}
	}
	return {text: r, bonus: bonus};
};

/**
 * Returns the effect of a campaign launched from the PR hub.
 * @param {string} [focus] campaign option to check against.
 * @returns {{text:string, effect:number}}}
 */
App.SecExp.propagandaEffects = function(focus) {
	let t = ``, increase = 0;
	if (V.secExpEnabled > 0 && V.SecExp.buildings.propHub && V.SecExp.buildings.propHub.upgrades.campaign >= 1 && V.SecExp.buildings.propHub.focus === focus) {
		let campaign, modifier;
		const forcedViewing = V.SecExp.edicts.propCampaignBoost === 1;
		const noRecruiter = V.SecExp.buildings.propHub.recruiterOffice === 0 || V.RecruiterID === 0;
		const recruiterActive = V.SecExp.buildings.propHub.recruiterOffice && V.RecruiterID > 0;
		switch (focus) {
			case "social engineering":
				campaign = 'societal engineering';
				modifier = forcedViewing ? V.SecExp.buildings.propHub.upgrades.campaign : 1;
				if (noRecruiter) {
					increase += (forcedViewing ? 2 : 1) * modifier;
				} else if (recruiterActive) {
					increase += modifier + Math.floor((S.Recruiter.intelligence + S.Recruiter.intelligenceImplant) / 32);
				}
				break;
			case "recruitment":
				campaign = 'militia recruitment';
				modifier = forcedViewing ? 0.2 : 0.15;
				if (noRecruiter) {
					increase += modifier + (forcedViewing ? 0.1 : 0.05);
				} else if (recruiterActive) {
					increase += modifier + Math.floor((S.Recruiter.intelligence + S.Recruiter.intelligenceImplant) / 650);
				}
				break;
			case "immigration":
				modifier = forcedViewing ? V.SecExp.buildings.propHub.upgrades.campaign : 1;
				if (noRecruiter) {
					increase += (forcedViewing ? random(1, 4) : random(1, 2)) * modifier;
				} else if (recruiterActive) {
					increase += modifier + Math.floor((S.Recruiter.intelligence + S.Recruiter.intelligenceImplant) / 16);
				}
				t = `Your advertisement campaign outside the free city brings more people to the gates of your arcology`;
				break;
			case "enslavement":
				modifier = forcedViewing ? V.SecExp.buildings.propHub.upgrades.campaign : 1;
				if (noRecruiter) {
					increase += (forcedViewing ? random(0, 4) : random(0, 2)) * modifier;
				} else if (recruiterActive) {
					increase += modifier + Math.floor((S.Recruiter.intelligence + S.Recruiter.intelligenceImplant) / 16);
				}
				t = `Many were attracted by your advertisement campaigns.`;
				break;
		}

		if (focus === "social engineering" || focus === "recruitment") {
			t += `<span class='green'>Your propaganda campaign helps further your ${campaign} efforts.`;
			if (recruiterActive) {
				t += ` <span class='slave-name'>${SlaveFullName(S.Recruiter)}</span> is boosting your ${campaign} campaign.`;
			}
			t += `</span>`;
		}
	}
	return {text: t, effect: Math.round(increase)};
};

/**
 * Returns the raw percentage of society that can be drafted.
 * @returns {number}
 */
App.SecExp.militiaCap = function(x = 0) {
	x = x || V.SecExp.edicts.defense.militia;
	if (x === 2) {
		return 0.02;
	} else if (x === 3) {
		return 0.05;
	} else if (x === 4) {
		return 0.1;
	} else if (x === 5) {
		return 0.2;
	}
};

App.SecExp.initTrade = function() {
	if (V.SecExp.core.trade === 0 || !jsDef(V.SecExp.core.trade)) {
		let init = jsRandom(20, 30);
		if (V.terrain === "urban") {
			init += jsRandom(10, 10);
		} else if (V.terrain === "ravine") {
			init -= jsRandom(5, 5);
		}
		if (["BlackHat", "capitalist", "celebrity", "wealth"].includes(V.PC.career)) {
			init += jsRandom(5, 5);
		} else if (["escort", "gang", "servant"].includes(V.PC.career)) {
			init -= jsRandom(5, 5);
		}
		V.SecExp.core.trade = init;
	}
};

App.SecExp.generalInit = function() {
	if (V.secExpEnabled === 0) {
		return;
	}

	Object.assign(V.SecExp, {
		battles: {
			major: 0,
			slaveVictories: [],
			lastSelection: [],
			victories: 0,
			victoryStreak: 0,
			losses: 0,
			lossStreak: 0,
			lastEncounterWeeks: 0,
			saved: {}
		},
		rebellions: {
			tension: 0,
			slaveProgress: 0,
			citizenProgress: 0,
			victories: 0,
			losses: 0,
			lastEncounterWeeks: 0
		},
		core: {
			trade: 0,
			authority: 0,
			security: 100,
			crimeLow: 30,
			totalKills: 0,
		},
		settings: {
			difficulty: 1,
			unitDescriptions: 0,
			battle: {
				enabled: 1,
				allowSlavePrestige: 1,
				force: 0,
				showStats: 0,
				frequency: 1,
				major: {
					enabled: 0,
					gameOver: 1,
					mult: 1,
					force: 0
				}
			},
			rebellion: {
				enabled: 1,
				force: 0,
				gameOver: 1,
				speed: 1
			}
		},
		buildings: {},
		proclamation: {
			cooldown: 0,
			currency: "",
			type: "crime"
		},
		/* repairTime: {
			waterway: 0,
			assistant: 0,
			reactor: 0,
			arc: 0
		}, */
		units: {},
		edicts: {
			alternativeRents: 0,
			enslavementRights: 0,
			sellData: 0,
			propCampaignBoost: 0,
			tradeLegalAid: 0,
			taxTrade: 0,
			slaveWatch: 0,
			subsidyChurch: 0,
			SFSupportLevel: 0,
			limitImmigration: 0,
			openBorders: 0,
			weaponsLaw: 3,
			defense: {
				soldierWages: 1,
				slavesOfficers: 0,
				discountMercenaries: 0,
				militia: 0,
				militaryExemption: 0,
				noSubhumansInArmy: 0,
				pregExemption: 0,
				liveTargets: 0,
				privilege: {
					militiaSoldier: 0,
					slaveSoldier: 0,
					mercSoldier: 0,
				},
				// Soldiers
				martialSchool: 0,
				eliteOfficers: 0,
				lowerRequirements: 0,
				// FS soldiers
				legionTradition: 0,
				eagleWarriors: 0,
				ronin: 0,
				sunTzu: 0,
				mamluks: 0,
				pharaonTradition: 0,
			}
		},
		smilingMan: {progress: 0}
	});

	for (const unit of App.SecExp.unit.list()) {
		App.SecExp.unit.gen(unit);
	}
	App.SecExp.initTrade();
};

App.SecExp.upkeep = (function() {
	return {
		edictsCash,
		edictsAuth,
		SF,
		buildings
	};

	/** Upkeep cost of edicts, in cash
	 * @returns {number}
	 */
	function edictsCash() {
		let value = 0;
		if (V.SecExp.edicts.slaveWatch) { value++; }
		if (V.SecExp.edicts.subsidyChurch) { value++; }
		if (V.SecExp.edicts.tradeLegalAid) { value++; }
		if (V.SecExp.edicts.propCampaignBoost) { value++; }

		if (V.SecExp.edicts.defense.martialSchool) { value++; }

		if (V.SecExp.edicts.defense.legionTradition) { value++; }
		if (V.SecExp.edicts.defense.pharaonTradition) { value++; }
		if (V.SecExp.edicts.defense.eagleWarriors) { value++; }
		if (V.SecExp.edicts.defense.ronin) { value++; }
		if (V.SecExp.edicts.defense.mamluks) { value++; }
		if (V.SecExp.edicts.defense.sunTzu) { value++; }

		return value * 1000;
	}

	/** Upkeep cost of edicts, in authority
	 * @returns {number}
	 */
	function edictsAuth() {
		let value = 0;
		if (V.SecExp.edicts.enslavementRights > 0) {
			value += 10;
		}
		if (V.SecExp.edicts.sellData === 1) {
			value += 10;
		}
		if (V.SecExp.edicts.defense.privilege.slaveSoldier === 1) {
			value += 10;
		}
		if (V.SecExp.edicts.weaponsLaw === 0) {
			value += 30;
		} else if (V.SecExp.edicts.weaponsLaw === 1) {
			value += 20;
		} else if (V.SecExp.edicts.weaponsLaw === 2) {
			value += 10;
		}
		if (V.SecExp.edicts.defense.slavesOfficers === 1) {
			value += 10;
		}
		return value;
	}

	/** Upkeep cost of Special Forces (why is this here? who knows!)
	 * @returns {number}
	 */
	function SF() {
		let value = 0;
		if (V.SecExp.edicts.SFSupportLevel >= 1) {
			value += 1000;
		}
		if (V.SecExp.edicts.SFSupportLevel >= 2) {
			value += 2000;
		}
		if (V.SecExp.edicts.SFSupportLevel >= 3) {
			value += 3000;
		}
		if (V.SecExp.edicts.SFSupportLevel >= 4) {
			value += 3000;
		}
		if (V.SecExp.edicts.SFSupportLevel >= 5) {
			value += 4000;
		}
		return value;
	}

	/** Upkeep cost of buildings (in cash)
	 * @returns {number}
	 */
	function buildings() {
		let value = 0;
		const base = V.facilityCost * 5, upgrade = 50;
		if (V.SecExp.buildings.propHub) {
			value += base + upgrade * Object.values(V.SecExp.buildings.propHub.upgrades).reduce((a, b) => a + b);
		}
		if (V.SecExp.buildings.secHub) {
			value += base + 20 * V.SecExp.buildings.secHub.menials;
			value += upgrade * Object.values(V.SecExp.buildings.secHub.upgrades.security).reduce((a, b) => a + b);
			value += upgrade * Object.values(V.SecExp.buildings.secHub.upgrades.crime).reduce((a, b) => a + b);
			value += upgrade * Object.values(V.SecExp.buildings.secHub.upgrades.readiness).reduce((a, b) => a + b);
			value += upgrade * Object.values(V.SecExp.buildings.secHub.upgrades.intel).reduce((a, b) => a + b);
			value += V.SecExp.edicts.SFSupportLevel >= 5 ? 1000 : 0;
		}
		if (V.SecExp.buildings.barracks) {
			value += base + upgrade * Object.values(V.SecExp.buildings.barracks).reduce((a, b) => a + b);
		}
		if (V.SecExp.buildings.riotCenter) {
			value += base + upgrade * Object.values(V.SecExp.buildings.riotCenter.upgrades).reduce((a, b) => a + b);
			if (V.SecExp.buildings.riotCenter.brainImplant < 106 && V.SecExp.buildings.riotCenter.brainImplantProject > 0) {
				value += 5000 * V.SecExp.buildings.riotCenter.brainImplantProject;
			}
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.rebellions.sfArmor) {
				value += 15000;
			}
		}
		return value;
	}
})();

App.SecExp.battle = (function() {
	"use strict";
	return {
		deployedUnits,
		troopCount,
		deploySpeed,
		deployableUnits,
		activeUnits,
		maxUnits,
		recon,
		bribeCost,
	};

	/** Get count of deployed/active units for a particular battle
	 * @param {string} [input] unit type to measure; if omitted, count all types
	 * @returns {number} unit count
	 */
	function deployedUnits(input = '') {
		let count = {}, init = 0;
		App.SecExp.unit.list().forEach(s => { count[s] = 0; });
		if (V.slaveRebellion === 0 && V.citizenRebellion === 0) { // attack
			if (V.SecExp.units.bots.isDeployed > 0) {
				count.bots++;
			}
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
				init++;
			}
		} else { // rebellion
			if (V.SecExp.units.bots.active > 0) {
				count.bots++;
			}
			if (V.SF.Toggle && V.SF.Active >= 1) {
				init++;
			}
			if (V.SecExp.war.irregulars > 0) {
				count.militia++;
			}
		}
		
		App.SecExp.unit.list().slice(1).forEach(s => { count[s] += V.SecExp.units[s].squads.filter((u) => App.SecExp.unit.isDeployed(u)).length; });

		if (input === '') {
			return Object.values(count).reduce((a, b) => a + b) + init;
		} else {
			return count[input];
		}
	}

	/** Get total troop count of deployed/active units for a particular battle
	 * @returns {number} troop count
	 */
	function troopCount() {
		let troops = 0;

		/** @param {function(FC.SecExp.PlayerHumanUnitData) : boolean} pred */
		function countHumanTroops(pred) {
			let arrays = [];
			Object.values(V.SecExp.units).slice(1).forEach(s => { arrays.push(s.squads); });
			for (const arr of arrays) {
				for (const unit of arr) {
					if (pred(unit)) {
						troops += unit.troops;
					}
				}
			}
		}

		if (V.slaveRebellion === 0 && V.citizenRebellion === 0) { // attack
			if (V.SecExp.units.bots.isDeployed === 1) {
				troops += V.SecExp.units.bots.troops;
			}
			countHumanTroops((u) => u.isDeployed === 1);
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
				troops += App.SecExp.troopsFromSF();
			}
		} else {
			if (V.SecExp.war.irregulars > 0) {
				troops += V.SecExp.war.irregulars;
			}
			if (V.SecExp.units.bots.active === 1) {
				troops += V.SecExp.units.bots.troops;
			}
			countHumanTroops((u) => u.active === 1 && !V.SecExp.war.rebellingID.includes(u.ID));
			if (V.SF.Toggle && V.SF.Active >= 1) {
				troops += App.SecExp.troopsFromSF();
			}
		}
		return troops;
	}

	/** Get mobilization readiness (in *pairs* of units) given upgrades
	 * @returns {number} readiness
	 */
	function deploySpeed() {
		let init = 1;
		if (V.SecExp.buildings.secHub) {
			if (V.SecExp.buildings.secHub.upgrades.readiness.pathways > 0) {
				init += 1;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.rapidVehicles > 0) {
				init += 2;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.rapidPlatforms > 0) {
				init += 2;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.earlyWarn > 0) {
				init += 2;
			}
		}
		if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.sectionInFirebase >= 1) {
			init += 2;
		}
		return init;
	}

	/** Get remaining deployable units (mobilization in units minus units already deployed)
	 * @returns {number}
	 */
	function deployableUnits() {
		let init = 2 * App.SecExp.battle.deploySpeed();
		if (V.SecExp.units.bots.isDeployed > 0) {
			init--;
		}

		for (const squad of App.SecExp.unit.humanSquads()) {
			if (squad.isDeployed > 0) {
				init--;
			}
		}

		return Math.max(0, init);
	}

	/** Get total active units
	 * @returns {number}
	 */
	function activeUnits() {
		return V.SecExp.units.bots.active + App.SecExp.unit.humanSquads().length;
	}

	/** Get maximum active units
	 * @returns {number}
	 */
	function maxUnits() {
		let max = 0;
		if (V.SecExp.buildings.barracks) {
			max += 8 + (V.SecExp.buildings.barracks.size * 2);
			if (App.SecExp.battle.deploySpeed() === 10) {
				max += 2;
			}
		}
		return max;
	}

	/** Get recon score (scale 0-3)
	 * @returns {number}
	 */
	function recon() {
		return V.SecExp.buildings.secHub ? Object.values(V.SecExp.buildings.secHub.upgrades.intel).reduce((a, b) => a + b) : 0;
	}

	/** Get bribe cost for an attacker to go away
	 * @returns {number}
	 */
	function bribeCost() {
		let cost; const baseBribePerAttacker = 5;
		if (V.week <= 30) {
			cost = 5000 + baseBribePerAttacker * V.SecExp.war.attacker.troops;
		} else if (V.week <= 40) {
			cost = 10000 + baseBribePerAttacker * V.SecExp.war.attacker.troops;
		} else if (V.week <= 50) {
			cost = 15000 + baseBribePerAttacker * V.SecExp.war.attacker.troops;
		} else if (V.week <= 60) {
			cost = 20000 + baseBribePerAttacker * V.SecExp.war.attacker.troops;
		} else if (V.week <= 70) {
			cost = 25000 + baseBribePerAttacker * V.SecExp.war.attacker.troops;
		} else {
			cost = 30000 + baseBribePerAttacker * V.SecExp.war.attacker.troops;
		}
		cost *= V.majorBattle > 0 ? 3 : 1;
		return Math.trunc(Math.clamp(cost, 0, 1000000));
	}
})();

App.SecExp.Check = (function() {
	"use strict";
	return {
		secRestPoint,
		crimeCap,
		reqMenials,
	};

	function secRestPoint() {
		let rest = 40;
		if (V.SecExp.buildings.secHub) {
			if (V.SecExp.buildings.secHub.upgrades.security.nanoCams === 1) {
				rest += 15;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.cyberBots === 1) {
				rest += 15;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.eyeScan === 1) {
				rest += 20;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.cryptoAnalyzer === 1) {
				rest += 20;
			}
		}
		return rest;
	}

	function crimeCap() {
		let cap = 100;
		if (V.SecExp.buildings.secHub) {
			if (V.SecExp.buildings.secHub.upgrades.crime.autoTrial === 1) {
				cap -= 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.autoArchive === 1) {
				cap -= 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.worldProfiler === 1) {
				cap -= 15;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.advForensic === 1) {
				cap -= 15;
			}
		}
		return cap;
	}

	function reqMenials() {
		let Req = 20;
		if (V.SecExp.buildings.secHub) {
			if (V.SecExp.buildings.secHub.upgrades.security.nanoCams === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.cyberBots === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.eyeScan === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.security.cryptoAnalyzer === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.autoTrial === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.autoArchive === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.worldProfiler === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.crime.advForensic === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.intel.sensors === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.intel.signalIntercept === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.intel.radar === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.rapidVehicles === 1) {
				Req += 5;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.rapidPlatforms === 1) {
				Req += 10;
			}
			if (V.SecExp.buildings.secHub.upgrades.readiness.earlyWarn === 1) {
				Req += 10;
			}
			Req -= 5 * V.SecExp.edicts.SFSupportLevel;
			Req -= 10 * V.SecExp.buildings.secHub.coldstorage;
		}
		return Req;
	}
})();

App.SecExp.inflictBattleWound = (function() {
	/** @typedef {object} Wound
	 * @property {number} weight
	 * @property {function(App.Entity.SlaveState):boolean} allowed
	 * @property {function(App.Entity.SlaveState):void} effects
	 */
	/** @type { Object<string, Wound> } */
	const wounds = {
		eyes: {
			weight: 10,
			allowed: (s) => canSee(s),
			effects: (s) => { clampedDamage(s, 30); eyeSurgery(s, "both", "blind"); }
		},
		voice: {
			weight: 10,
			allowed: (s) => canTalk(s),
			effects: (s) => { clampedDamage(s, 60); s.voice = 0; }
		},
		legs: {
			weight: 5,
			allowed: (s) => hasAnyNaturalLegs(s),
			effects: (s) => { clampedDamage(s, 80); removeLimbs(s, "left leg"); removeLimbs(s, "right leg"); }
		},
		arm: {
			weight: 5,
			allowed: (s) => hasAnyNaturalArms(s),
			effects: (s) => { clampedDamage(s, 60); removeLimbs(s, jsEither(["left arm", "right arm"])); }
		},
		flesh: {
			weight: 70,
			allowed: () => true,
			effects: (s) => { clampedDamage(s, 30); }
		}
		// TODO: add more wound types? destroy prosthetics?
	};

	/** Inflicts a large amount of damage upon a slave without killing them (i.e. leaving their health total above -90)
	 * @param {App.Entity.SlaveState} slave
	 * @param {number} magnitude
	 */
	function clampedDamage(slave, magnitude) {
		if ((slave.health.health - magnitude) > -90) {
			healthDamage(slave, magnitude);
		} else {
			healthDamage(slave, 90 + slave.health.health);
		}
	}

	/** Inflicts a wound upon a slave during a battle. Returns the wound type from the wound table (see above) so it can be described.
	 * @param {App.Entity.SlaveState} slave
	 * @returns {string}
	 */
	function doWound(slave) {
		let woundHash = {};
		for (const w of Object.keys(wounds)) {
			if (wounds[w].allowed(slave)) {
				woundHash[w] = wounds[w].weight;
			}
		}
		/** @type {string} */
		// @ts-ignore - FIXME: hashChoice has bad JSDoc
		const wound = hashChoice(woundHash);
		wounds[wound].effects(slave);
		return wound;
	}

	return doWound;
})();
