App.EndWeek.corporationDevelopments = function() {
	const el = document.createElement("p");
	let r;
	/* Main Corporation Pass*/

	if (App.Corporate.cash < 0) {
		App.Corporate.cash = Math.trunc(App.Corporate.cash * 1.02); /* 2% weekly interest rate on negative cash*/
	}
	App.UI.DOM.appendNewElement("h1", el, "Corporation Management");
	App.UI.DOM.appendNewElement("h2", el, "Operational Results");
	/* Divisions doing their thing*/
	const _weekLedger = App.Corporate.endWeek();
	for (const i in _weekLedger.divisionLedgers) {
		const _d = _weekLedger.divisionLedgers[i];
		const _div = _d.division;
		let r;
		/* Reporting on number of slaves being processed or completed processing */
		App.Events.addNode(el, [`${_div.name}: The division ${_div.message_endWeek_Slaves(_d)}`], "div");

		r = [];
		if (_d.market.originalBuy != null) {
			if (_d.market.buy === 0) {
				r.push(`It couldn't purchase ${numberWithPlural(_d.market.originalBuy, "slave")} to replenish its stock from the market because it couldn't afford to purchase price.`);
			} else {
				r.push(`It needed to replenish its slave stock of ${numberWithPlural(_d.market.originalBuy, "slave")}, but couldn't afford to buy all of them. It bought ${numberWithPlural(_d.market.buy, _div.nounSlaveFromMarket)} for ${cashFormatColor(_d.market.finalPurchase, true)}.`);
			}
		} else if (_d.market.buy > 0) {
			r.push(`It replenished its slave stock and bought ${numberWithPlural(_d.market.buy, _div.nounSlaveFromMarket)} from the market for ${cashFormatColor(_d.market.finalPurchase, true)}.`);
		}
		App.Events.addNode(el, r, "div");

		if (_d.transfer.total > 0) {
			for (const i in _d.transfer.divisions) {
				const _nextDivLedger = _d.transfer.divisions[i];
				const _nextDiv = _nextDivLedger.division;
				const _slavesToNext = _nextDivLedger.fill;
				App.Events.addNode(el, [`It moved ${numberWithPlural(_slavesToNext, "slave")} to the ${_nextDiv.name} Division.`], "div");
			}
		}
		if (_div.toMarket) {
			r = [];
			if (_div.heldSlaves === 0) {
				if (_d.market.sell > 0) {
					r.push(`It immediately sold ${numberWithPlural(_d.market.sell, _div.nounFinishedSlave)} to the market and made ${cashFormatColor(_d.market.finalSale)}.`);
				}
			} else {
				r.push(`It holds <span class="green">${numberWithPlural(_div.heldSlaves, _div.nounFinishedSlave)}</span> at the end of the`);
				if (_d.market.sell > 0) {
					r.push(`week, but it ran out of storage space and had to sell <span class="red">${numberWithPlural(_d.market.sell, "slave")}</span> and made ${cashFormatColor(_d.market.finalSale)}.`);
				} else {
					r.push(`week.`);
				}
			}
			App.Events.addNode(el, r, "div");
		}
		if (_d.revenue.value > 0) {
			App.Events.addNode(el, [`It earned ${cashFormatColor(_d.revenue.value)} in revenue.`], "div");
		}
	}

	/* Aggregate Corporation Results*/
	el.append(App.Corporate.writeLedger(App.Corporate.ledger.current, V.week));

	/* Division Expansion Tokens*/
	if (_weekLedger.canExpandNow) {
		App.UI.DOM.appendNewElement("div", el, "Your corporation is ready to start an additional division!", "majorText");
	}

	/* Specializations tokens*/
	if (_weekLedger.canSpecializeNow) {
		App.UI.DOM.appendNewElement("div", el, "Your corporation is ready to specialize its slaves further!", "majorText");
	}

	/* Calculating cash set aside for dividend*/
	App.UI.DOM.appendNewElement("h2", el, "Dividend");
	r = [];
	if (App.Corporate.dividendRatio > 0) {
		r.push(`The corporation is currently reserving ${Math.floor(App.Corporate.dividendRatio * 100)}% of its profit to be paid out as dividends.`);
	} else {
		r.push(`The corporation is currently not reserving a portion of its profit to be paid out as dividends.`);
	}
	if (App.Corporate.payoutCash) {
		r.push(`It is putting aside unused cash reserves to be paid out as dividends.`);
	}
	App.Events.addNode(el, r, "div");

	if (App.Corporate.dividend > 0) {
		r = [];
		if (_weekLedger.hasDividend) {
			r.push(`It reserved ${cashFormatColor(_weekLedger.dividend)} this week.`);
		}
		r.push(`A total of ${cashFormatColor(App.Corporate.dividend)} has been put aside for its shareholders.`);
		App.Events.addNode(el, r, "div");
	}

	if (_weekLedger.hasPayout) {
		App.Events.addNode(el, [`This week the dividends were paid out, you received ${cashFormatColor(_weekLedger.payout)}.`], "div");
	}

	/* Bankrupted the Corporation*/
	if (App.Corporate.value < 0) {
		App.Corporation.Dissolve();
		App.UI.DOM.appendNewElement("div", el, "Your corporation went bankrupt.", "red");
	}
	/* This needs to be at the very end of the financials*/
	App.Corporate.ledger.swap();
	return el;
};
