App.Facilities.Farmyard.farmyardReport = function farmyardReport() {
	let frag = new DocumentFragment();

	const slaves = App.Utils.sortedEmployees(App.Entity.facilities.farmyard);
	const devBonus = (V.farmyardDecoration !== "standard") ? 1 : 0;
	const Farmer = S.Farmer;

	let profits = 0;
	let foodWeek = 0;
	let farmerBonus = 0;



	// MARK: Farmer

	function farmerChanges() {
		farmerHealth(Farmer);
		farmerDevotion(Farmer);
		farmerTrust(Farmer);
		farmerLivingRules(Farmer);
		farmerRestRules(Farmer);
		farmerCashBonus(Farmer);
	}

	function farmerHealth(slave) {
		if (slave.health.condition < -80) {
			improveCondition(Farmer, 20);
		} else if (slave.health.condition < -40) {
			improveCondition(Farmer, 15);
		} else if (slave.health.condition < 0) {
			improveCondition(Farmer, 10);
		} else if (slave.health.condition < 90) {
			improveCondition(Farmer, 7);
		}
	}

	function farmerDevotion(slave) {
		slave.devotion += devBonus;

		if (slave.devotion < 45) {
			slave.devotion += 5;
		}
	}

	function farmerTrust(slave) {
		if (slave.trust < 45) {
			slave.trust += 5;
		}
	}

	const farmerLivingRules = slave => slave.rules.living = 'luxurious';
	const farmerRestRules = slave => slave.rules.rest = 'restrictive';

	function farmerCashBonus(slave) {
		let FarmerCashBonus = Math.min(0.2, slave.skill.farmer * 0.002);

		FarmerCashBonus += slave.intelligence + slave.intelligenceImplant > 15 ? 0.05 : 0;
		FarmerCashBonus += slave.dick > 2 && canPenetrate(slave) ? 0.05 : 0;
		FarmerCashBonus += !canSmell(slave) ? 0.05 : 0;

		if (slave.actualAge > 35) {
			FarmerCashBonus += 0.05;
		} else if (!V.AgePenalty) {
			FarmerCashBonus += 0.05;
		}

		if (App.Data.Careers.Leader.farmer.includes(slave.career)) {
			FarmerCashBonus += 0.05;
			if (slave.skill.farmer >= V.masteredXP) {
				FarmerCashBonus += 0.05;
			}
		} else if (slave.skill.farmer >= V.masteredXP) {
			FarmerCashBonus += 0.05;
		}

		// TODO: keep this?
		if (Farmer.relationshipTarget === slave.ID) {
			FarmerCashBonus -= 0.05;
		} else if (areRelated(Farmer, slave)) {
			FarmerCashBonus += 0.05;
		}

		FarmerCashBonus *= restEffects(Farmer);

		return FarmerCashBonus;
	}



	function farmerText() {
		let r = [];

		r.push(farmerIntro(Farmer));
		r.push(farmerRelationshipPC(Farmer));
		r.push(farmerFetishEffects(Farmer, farmerFetish(Farmer)));
		r.push(farmerSkill(Farmer));
		r.push(farmerExperience(Farmer));
		r.push(farmerTiredness(Farmer));
		r.push(farmerIntelligence(Farmer));
		r.push(farmerSmell(Farmer));
		r.push(farmerRelationshipSlaves(Farmer));
		r.push(farmerContracts(Farmer));

		return r.join(' ');
	}

	function farmerFetish(slave) {
		if (slave.fetish !== 'dom') {
			if (fetishChangeChance(slave) > jsRandom(0, 100)) {
				slave.fetishKnown = 1;
				slave.fetish = 'dom';
				slave.fetishStrength = 10;
				return 1;
			}
		} else if (!slave.fetishKnown) {
			slave.fetishKnown = 1;
			return 1;
		} else {
			slave.fetishStrength += 4;
			return 2;
		}
	}

	function farmerFetishEffects(slave, fetish = 0) {
		const {he, his, himself, He} = getPronouns(slave);

		if (fetish === 1) {
			return `${He} isn't above sampling the merchandise ${himself}; before long it's obvious to ${his} workers that ${he} <span class="lightcoral">really likes fucking them.</span> `;
		} else if (fetish === 2) {
			return `${He}'s careful that all of the farmhands under ${his} supervision are all ready to work every morning, and ${he} <span class="lightsalmon">becomes more dominant.</span> `;
		}
	}

	function farmerSkill(slave) {
		const {he, his, His} = getPronouns(slave);

		let r = [];

		if (slave.skill.farmer <= 10) {
			r.push(`Though ${slave.slaveName} does ${his} best to manage the farmyard, with ${his} lack of skill ${he} can do little.`);
		} else if (slave.skill.farmer <= 30) {
			r.push(`${slave.slaveName}'s basic skills marginally <span class="yellowgreen">improve</span> business at ${V.farmyardName}.`);
		} else if (slave.skill.farmer <= 60) {
			r.push(`${slave.slaveName}'s skills <span class="yellowgreen">improve</span> business at ${V.farmyardName}.`);
		} else if (slave.skill.farmer < 100) {
			r.push(`${slave.slaveName}'s skills greatly <span class="yellowgreen">improve</span> business at ${V.farmyardName}.`);
		} else {
			r.push(`${slave.slaveName}'s mastery immensely <span class="yellowgreen">improves</span> business at ${V.farmyardName}.`);
		}

		if (slave.actualAge > 35) {
			r.push(`${His} age and experience also contribute.`);
		}

		return r.join(' ');
	}

	function farmerExperience(slave) {
		const {he, his, him, He} = getPronouns(slave);

		if (App.Data.Careers.Leader.farmer.includes(slave.career)) {
			return `${He} has experience from ${his} life before ${he} was a slave that helps ${him} in the difficult life of managing animals and property.`;
		} else if (slave.skill.farmer >= V.masteredXP) {
			return `${He} has experience from working for you that helps ${him} in the difficult life of managing animals and property.`;
		} else {
			slave.skill.farmer += jsRandom(1, Math.ceil((slave.intelligence + slave.intelligenceImplant) / 32));
		}
	}

	function farmerTiredness(slave) {
		const {he, his, him, He} = getPronouns(slave);

		if (slaveResting(slave)) {
			return `To avoid exhaustion, ${he} has to take breaks to maintain ${his} strength, limiting how much ${he} can work.`;
		}
	}

	function farmerRelationshipSlaves(Farmer) {
		const {he, his, He} = getPronouns(Farmer);

		let r = [];

		for (const slave of slaves) {
			if (Farmer.rivalryTarget === slave.ID) {
				r.push(`${He} leverages the fact that ${he} is ${slave.slaveName}'s superior to make ${his} ${rivalryTerm(Farmer)}'s life a living hell.`);
				slave.devotion -= 2; slave.trust -= 2;

				if (canDoVaginal(slave)) {
					seX(slave, 'vaginal', 'public', 'penetrative', 10);
				}

				if (canDoAnal(slave)) {
					seX(slave, 'anal', 'public', 'penetrative', 10);
				}

				seX(slave, 'oral', 'public', 'penetrative', 10);
				if (jsRandom(1, 100) > 65) {
					Farmer.rivalry++; slave.rivalry++;
				}
			} else if (Farmer.relationshipTarget === slave.ID) {
				r.push(`${He} dotes over ${his} ${relationshipTerm(Farmer)}, ${slave.slaveName}, making sure ${he} isn't worked too hard, but unfortunately manages to get in the way of ${his} work.`);
				slave.devotion++;
			} else if (areRelated(Farmer, slave)) {
				r.push(`${He} pays special attention to ${his} ${relativeTerm(Farmer, slave)}, ${slave.slaveName}, making sure ${he} is treated well and showing off ${his} skills.`);
				slave.trust++;
			}
		}

		return r;
	}

	function farmerContracts(slave) {
		const {he, his, himself} = getPronouns(slave);

		let r = [];
		let seed = V.farmyardShowgirls ? App.Facilities.Farmyard.farmShowsIncome(slave) : jsRandom(1, 10) * (jsRandom(150, 170) + (farmerBonus * 10));

		if (V.farmyardShows && !V.farmyardShowgirls) {
			r.push(`<p class="indent">Since ${he} doesn't have enough showgirls to entertain your arcology's citizens, ${he} puts on shows with your animals on ${his} own, earning <span class="yellowgreen">${cashFormat(seed)}.</span></p>`);
		} else if (!V.farmyardFarmers) {
			r.push(`<p class="indent">Since ${V.farmyardName} doesn't have anyone tending to the crops, ${he} looks after them ${himself}, earning <span class="yellowgreen">${cashFormat(seed)}.</span></p>`);
		}

		return r;
	}

	function farmerRelationshipPC(slave) {
		const {he, his, wife} = getPronouns(slave);

		if (slave.relationship === -3 && slave.devotion > 50) {
			return `As your loving ${wife}, ${he} does ${his} best to ensure ${V.farmyardName} runs smoothly.`;
		}
	}

	function farmerIntelligence(slave) {
		const {He} = getPronouns(slave);

		if (slave.intelligence + slave.intelligenceImplant > 15) {
			return `${He} is a clever manager.`;
		}
	}

	function farmerSmell(slave) {
		const {him, His} = getPronouns(slave);

		if (!canSmell(slave)) {
			return `${His} lack of a sense of smell protects ${him} from that omnipresent barnyard stench.`;
		}
	}

	const farmerIntro = slave => `<span class="indent">${SlaveFullName(slave)} is serving as the Farmer</span>.`;

	if (Farmer) {
		const farmerEffects = App.UI.DOM.appendNewElement("p", frag, '', "indent");

		if (V.showEWD) {
			const farmerEntry = App.UI.DOM.appendNewElement("div", frag, '', "slave-report");
			App.SlaveAssignment.appendSlaveArt(farmerEntry, Farmer);
			farmerEntry.append(App.UI.favoriteToggle(Farmer), " ");
			$(farmerEntry).append(`<span class="slave-name">${SlaveFullName(Farmer)}</span> is serving as the Farmer.`);
			farmerEntry.append(App.SlaveAssignment.standardSlaveReport(Farmer, false));
		} else {
			App.SlaveAssignment.standardSlaveReport(Farmer, true);
		}

		farmerChanges();
		$(farmerEffects).append(farmerText());
	}



	// MARK: Farmhands

	function farmhandCount(count) {
		return `<strong>There ${count > 1 ? `are ${count} farmhands` : `is one farmhand`} working out of ${V.farmyardName}.</strong>`;
	}

	function farmhandLivingRules(slave) {
		switch (V.farmyardDecoration) {
			case 'Degradation':
			case 'standard':
				slave.rules.living = 'spare';
				break;
			case 'Roman Revivalist':
				slave.rules.living = 'luxurious';
				break;
			default:
				slave.rules.living = 'normal';
				break;
		}
	}

	function farmhandHealth(slave) {
		if (slave.health.condition < -80) {
			improveCondition(slave, 20);
		} else if (slave.health.condition < -40) {
			improveCondition(slave, 15);
		} else if (slave.health.condition < 0) {
			improveCondition(slave, 10);
		} else if (slave.health.condition < 90) {
			improveCondition(slave, 7);
		}
	}

	function farmhandDevotion(slave) {
		if (slave.devotion <= 20 && slave.trust >= -20) {
			slave.devotion -= 5; slave.trust -= 5;
		} else if (slave.devotion < 45) {
			slave.devotion += 4;
		} else if (slave.devotion > 50) {
			slave.devotion -= 4;
		}
	}

	function farmhandProfit(slave) {
		let incomeStats = getSlaveStatisticData(slave, slave.assignment === Job.FARMYARD ? V.facility.farmyard : undefined);
		return incomeStats.income;
	}

	function farmhandFood(slave) {
		let incomeStats = getSlaveStatisticData(slave, slave.assignment === Job.FARMYARD ? V.facility.farmyard : undefined);
		let foodWeek = incomeStats.food || 0;

		if (V.farmMenials > 0) {
			foodWeek += (V.farmMenials * 350);
		}

		return foodWeek;
	}

	function farmhandTrust(slave) {
		if (slave.trust < 30) {
			slave.trust += 5;
		}
	}

	function farmhandEnergy(slave) {
		if (slave.energy > 40 && slave.energy < 95) {
			slave.energy++;
		}
	}

	if (slaves) {
		const intro = App.UI.DOM.appendNewElement("p", frag, '', "indent");

		$(intro).append(farmhandCount(slaves.length));

		for (const slave of slaves) {
			slave.devotion += devBonus;

			if (V.showEWD) {
				const slaveEntry = App.UI.DOM.appendNewElement("div", frag, '', "slave-report");
				App.SlaveAssignment.appendSlaveArt(slaveEntry, slave);
				slaveEntry.append(App.UI.favoriteToggle(slave), " ");
				$(slaveEntry).append(`<span class="slave-name">${SlaveFullName(slave)}</span> `);

				if (slave.choosesOwnAssignment === 2) {
					$(slaveEntry).append(App.SlaveAssignment.choosesOwnJob(slave));
				} else {
					$(slaveEntry).append(`is working out of ${V.farmyardName}.`);
				}

				farmhandLivingRules(slave);
				farmhandHealth(slave);
				farmhandDevotion(slave);
				farmhandTrust(slave);
				farmhandEnergy(slave);
				farmhandFood(slave);

				profits += farmhandProfit(slave);

				const farmhandContent = App.UI.DOM.appendNewElement("div", slaveEntry, '', "indent");

				$(farmhandContent).append(App.SlaveAssignment.workTheFarm(slave));
				slaveEntry.append(App.SlaveAssignment.standardSlaveReport(slave, false));
			} else {	// silently discard return values
				App.SlaveAssignment.workTheFarm(slave);
				App.SlaveAssignment.standardSlaveReport(slave, true);
			}
		}
	}



	// MARK: Menials

	if (V.farmMenials) {
		let farmMenialProductivity = 9;

		if (V.farmyardUpgrades.pump) {
			farmMenialProductivity += 1;
		}

		if (V.farmyardUpgrades.fertilizer) {
			farmMenialProductivity += 2;
		}

		if (V.farmyardUpgrades.seeds) {
			farmMenialProductivity += 3;
		}

		if (V.farmyardUpgrades.machinery) {
			farmMenialProductivity += 3;
		}

		foodWeek += (V.farmMenials * farmMenialProductivity);
	}



	// MARK: Farmyard

	function farmyardStatsRecords() {
		const f = V.facility.farmyard;

		if (typeof f === "undefined") {
			return;
		}

		f.farmhandIncome = 0;
		f.customers = 0;
		f.farmhandCosts = 0;
		f.rep = 0;
		f.maintenance = V.farmyard * V.facilityCost;
		f.totalIncome = f.farmhandIncome + f.adsIncome;
		f.totalExpenses = f.farmhandCosts + f.maintenance;
		f.profit = f.totalIncome - f.totalExpenses;

		for (let i of f.income.values()) {
			f.farmhandIncome += i.income + i.adsIncome;
			f.customers += i.customers;
			f.farmhandCosts += i.cost;
			f.rep += i.rep;
		}
	}

	function farmyardDecoration() {
		let r = [];

		// TODO: add checks for the different FSs
		if (V.farmyardDecoration !== 'standard') {
			const decorationEffects = App.UI.DOM.appendNewElement("p", frag, '', "indent");
			const farmyardNameCaps = capFirstChar(V.farmyardName);

			$(decorationEffects).append(document.createElement("br"));

			r.push(`${farmyardNameCaps}'s customer's enjoyed`);

			if (V.seeBestiality && V.policies.bestialityOpenness && (V.canine || V.hooved || V.feline)) {
				r.push(`<span class="green">watching farmhands fuck animals in ${V.farmyardDecoration} surroundings.</span>`);
			} else if (V.farmyardShows) {
				r.push(`<span class="green">watching farmhands put on shows in ${V.farmyardDecoration} surroundings.</span>`);
			} else {
				r.push(`<span class="green">partaking of ${V.farmyardName}'s fine produce in its ${V.farmyardDecoration} décor.</span>`);
			}

			$(decorationEffects).append(r.join(' '));
		}

		return r;
	}

	function farmyardProfit(profit, food) {
		const profitContent = App.UI.DOM.appendNewElement("p", frag, '', "indent");
		const farmyardNameCaps = capFirstChar(V.farmyardName);

		let r = [];

		$(profitContent).append(document.createElement("br"));

		if (profit || food) {
			r.push(farmyardNameCaps);

			if (profit) {
				r.push(`makes you <span class="yellowgreen">${cashFormat(Math.trunc(profit))}</span>`);
			}

			if (V.foodMarket) {
				if (profit && food) {
					r.push(`and`);
				}
				if (food) {
					r.push(`produced <span class="chocolate"> ${massFormat(food)}</span> of food`);
				}
			}
			r.push(`this week.`);
		}

		return $(profitContent).append(r.join(' '));
	}

	// FIXME: no idea what I'm doing here
	const statsSpan = document.createElement("span");

	farmyardStatsRecords();
	farmyardProfit(profits, foodWeek);
	farmyardDecoration();

	V.food += foodWeek;

	frag.append(App.Facilities.Farmyard.Stats(false));
	statsSpan.append(App.Facilities.Farmyard.Stats(true));

	return frag;
};
