/**
 * @returns {DocumentFragment}
 */
App.EndWeek.spaReport = function() {
	const el = new DocumentFragment();
	let r;

	const slaves = App.Utils.sortedEmployees(App.Entity.facilities.spa);
	let healthBonus = 0, restedSlaves = 0, restedSlave;
	let devBonus = (V.spaDecoration !== "standard") ? 1 : 0;

	V.flSex = App.EndWeek.getFLSex(App.Entity.facilities.spa); /* FIXME: should be local, passed as a parameter to saRules */

	if (S.Attendant) {
		let idleBonus = 0;
		let bonusToggle = 0;
		let FLsFetish = 0;
		r = [];

		if (S.Attendant.health.condition < 100) {
			improveCondition(S.Attendant, normalRandInt(20));
		}
		if (S.Attendant.devotion <= 60) {
			S.Attendant.devotion++;
		}
		if (S.Attendant.trust < 60) {
			S.Attendant.trust++;
		}
		if (S.Attendant.rules.living !== "luxurious") {
			S.Attendant.rules.living = "luxurious";
		}
		if (S.Attendant.fetishStrength <= 95) {
			if (S.Attendant.fetish !== "submissive") {
				if (fetishChangeChance(S.Attendant) > random(0, 100)) {
					FLsFetish = 1;
					S.Attendant.fetishKnown = 1;
					S.Attendant.fetish = "submissive";
					S.Attendant.fetishStrength = 10;
				}
			} else if (S.Attendant.fetishKnown === 0) {
				FLsFetish = 1;
				S.Attendant.fetishKnown = 1;
			} else {
				FLsFetish = 2;
				S.Attendant.fetishStrength += 4;
			}
		}
		if (S.Attendant.fetish === "none" || S.Attendant.fetish === "submissive") {
			devBonus++;
		}
		S.Attendant.devotion += devBonus;
		const {
			He, His,
			he, his, him, himself, wife
		} = getPronouns(S.Attendant);
		r.push(`${SlaveFullName(S.Attendant)} is serving as the spa attendant.`);
		if (S.Attendant.relationship === -3 && S.Attendant.devotion > 50) {
			r.push(`${He} tries ${his} best to be your perfect attentive, caring and loving ${wife}.`);
		}
		if (FLsFetish === 1) {
			r.push(`When ${he} is paid a visit by a slave with sexual issues to work out, ${he} provides them with an understanding, willing, giving partner. ${He} finds real satisfaction in helping your slaves find sexual gratification, and <span class="lightsalmon">becomes a submissive.</span>`);
		} else if ((FLsFetish === 2)) {
			r.push(`Every new slave in the spa is a new person ${he} gets to connect with and serve. Sexually. <span class="lightsalmon">${He} becomes more submissive.</span>`);
		}
		if (App.Data.Careers.Leader.attendant.includes(S.Attendant.career)) {
			r.push(`${He} has experience with counseling from ${his} life before ${he} was a slave, making ${him} better at building rapport with troubled slaves, and giving ${him} a better chance of softening flaws into beneficial quirks.`);
			bonusToggle = 1;
			idleBonus++;
		} else if (S.Attendant.skill.attendant >= V.masteredXP) {
			r.push(`${He} has experience with counseling from working for you, making ${him} better at building rapport with troubled slaves, and giving ${him} a better chance of softening flaws into beneficial quirks.`);
			bonusToggle = 1;
			idleBonus++;
		} else {
			S.Attendant.skill.attendant += random(1, Math.ceil((S.Attendant.intelligence + S.Attendant.intelligenceImplant) / 15) + 8);
		}
		if (!canSee(S.Attendant)) {
			r.push(`${His} blindness allows ${him} to deeply connect with ${his} charges.`);
			idleBonus++;
		}
		if (S.Attendant.fetish === "none") {
			r.push(`${S.Attendant.slaveName} respects the slaves lounging in the spa, allowing them to relax completely.`);
			idleBonus++;
		} else if (S.Attendant.fetish === "submissive") {
			r.push(`${S.Attendant.slaveName} lets the slaves resting in the spa take the lead sexually, doing ${his} best to please them.`);
			idleBonus++;
		} else if (S.Attendant.fetishKnown === 1) {
			r.push(`${S.Attendant.slaveName} can't keep ${his} ${hasBothArms(S.Attendant) ? `hands` : `hand`} to ${himself}, preventing the slaves in the spa from relaxing completely.`);
		}
		if (S.Attendant.visualAge > 35) {
			r.push(`${His} apparent maturity encourages the slaves in the spa to relax and pour out their troubles to ${him}.`);
			healthBonus++;
			idleBonus++;
		}
		if (S.Attendant.intelligence + S.Attendant.intelligenceImplant > 15) {
			r.push(`${He}'s so intelligent ${he} can suss out the cause of slaves' emotional issues and counsel them effectively.`);
			idleBonus++;
		}
		if (isFertile(S.Attendant) || (S.Attendant.bellyPreg >= 1500) || (S.Attendant.counter.birthsTotal > 0) || (S.Attendant.bellyImplant >= 1500)) {
			r.push(`${He} has a natural mothering instinct and really makes ${his} charges feel at home.`);
			idleBonus++;
			healthBonus++;
		}
		let attendantUsedCure = false;
		App.Events.addNode(el, r, "div", "indent");
		const softenFlawBonus = bonusToggle ? 10 : 0;
		for (const slave of slaves) {
			const {he2, his2, him2} = getPronouns(slave).appendSuffix("2");
			r = [];
			if (slave.fetish === "mindbroken" && slave.health.condition > 20 && !attendantUsedCure && V.spaFix !== 2) {
				attendantUsedCure = true;
				if (random(1, 100) > 90 - S.Attendant.devotion) {
					const curedSlave = App.UI.DOM.makeElement("div", null, "indent");
					const curedArray = [`<span class="green">Something almost miraculous has happened.</span> ${S.Attendant.slaveName} has always refused to believe that ${slave.slaveName} could not be reached, and has lavished patient tenderness on ${him2} in ${V.spaName}. ${slave.slaveName} has begun to respond, and is stirring from ${his2} mental torpor.`];
					slave.devotion = -3;
					slave.sexualFlaw = "apathetic";
					slave.behavioralFlaw = either("hates men", "odd");
					slave.fetish = "none";
					slave.fetishKnown = 1;
					const gp = V.genePool.find(s => s.ID === slave.ID);
					if (gp.intelligence >= -95) {
						slave.intelligence = gp.intelligence - 30;
					}
					if (V.arcologies[0].FSPaternalist !== "unset" && V.arcologies[0].FSPaternalist > 0) {
						curedArray.push(`Society <span class="green">strongly approves</span> of${slave.slaveName} being restored to sanity, which advances ideals about enlightened slaveownership.`);
						V.arcologies[0].FSPaternalist += 0.01 * V.FSSingleSlaveRep;
						repX(2 * V.FSSingleSlaveRep * (V.arcologies[0].FSPaternalist / V.FSLockinLevel), "spa", slave);
					}
					App.Events.addNode(curedSlave, curedArray);
					r.push(curedSlave);
				}
			}
			if (bonusToggle === 1 && slave.trust < 60) {
				slave.trust++;
			}
			if (S.Attendant.rivalryTarget === slave.ID) {
				r.push(`${He} constantly harasses ${his} ${rivalryTerm(S.Attendant)}, ${slave.slaveName}, preventing ${him2} from getting comfortable and forcing ${him2} to keep ${his2} guard up.`);
				slave.devotion -= 4;
				slave.trust -= 4;
				if (random(1, 100) > 35) {
					S.Attendant.rivalry++;
					S.Attendant.rivalry++;
					slave.rivalry++;
				}
			} else if (S.Attendant.relationshipTarget === slave.ID) {
				r.push(`${He} dedicates most of ${his} attention to ${his} ${relationshipTerm(S.Attendant)}, ${slave.slaveName}, making ${his2} stress, both physical and mental, wash away.`);
				slave.devotion += 3;
				slave.trust += 3;
			} else if (areRelated(S.Attendant, slave)) {
				r.push(`${He} makes sure to spend extra time caring for ${his} ${relativeTerm(S.Attendant, slave)}, ${slave.slaveName}.`);
				slave.trust++;
				improveCondition(slave, 1);
			}
			switch (slave.prestigeDesc) {
				case "$He is a famed Free Cities whore, and commands top prices.":
					r.push(`${He} does ${his} best to relax the famous whore,${slave.slaveName}, making sure to`);
					if (slave.vagina > 2 || slave.anus > 2) {
						r.push(`pay special attention to ${his2} worn holes.`);
					} else {
						r.push(`get ${him2} clean and relaxed for ${his2} next usage.`);
					}
					slave.devotion += 3;
					slave.trust += 3;
					break;
				case "$He is a famed Free Cities slut, and can please anyone.":
					r.push(`${He} does ${his} best to soothe the famous entertainer, ${slave.slaveName}, letting ${him2} relax in blissful peace.`);
					slave.devotion += 3;
					slave.trust += 3;
					break;
				case "$He is remembered for winning best in show as a cockmilker.":
					if (slave.balls > 6 && slave.dick !== 0) {
						if (S.Attendant.fetish === "cumslut") {
							r.push(`${He} can't keep ${his} ${hasBothArms(S.Attendant) ? `hands` : `hand`} off ${slave.slaveName}'s cock and balls, but ${he2} doesn't mind being milked constantly. Before long, strands of cum can be found floating all throughout the bath.`);
							S.Attendant.fetishStrength += 4;
						} else {
							r.push(`${He} does ${his} best to accommodate ${slave.slaveName}'s massive genitals and tends to ${him2} whenever ${he2} feels a need for release.`);
							if (random(1, 100) > 65 && S.Attendant.fetish === "none") {
								r.push(`After taking several massive loads to the face, ${S.Attendant.slaveName} begins to find satisfaction in being coated in cum.`);
								S.Attendant.fetish = "cumslut";
							}
						}
					}
					slave.devotion += 3;
					slave.trust += 3;
					break;
				case "$He is remembered for winning best in show as a dairy cow.":
					if (slave.lactation > 0 && (slave.boobs - slave.boobsImplant) > 6000) {
						if (S.Attendant.fetish === "boobs") {
							r.push(`${He} can't keep ${his} ${hasBothArms(S.Attendant) ? `hands` : `hand`} off ${slave.slaveName}'s huge breasts, but ${he2} doesn't mind being milked constantly. Before long the bath gains a white tint.`);
							S.Attendant.fetishStrength += 4;
							S.Attendant.fetishStrength += 4;
						} else {
							r.push(`${He} does ${his} best to accommodate ${slave.slaveName}'s massive breasts and tends to ${him2} whenever ${he2} feels a need for release.`);
							if (random(1, 100) > 65 && S.Attendant.fetish === "none") {
								r.push(`After multiple milking sessions, ${S.Attendant.slaveName} begins to find ${himself} fantasizing about having giant milky breasts too.`);
								S.Attendant.fetish = "boobs";
							}
						}
						slave.devotion += 3;
						slave.trust += 3;
						slave.lactationDuration = 2;
						slave.boobs -= slave.boobsMilk;
						slave.boobsMilk = 0;
					}
					break;
				case "$He is remembered for winning best in show as a breeder.":
					if (slave.bellyPreg >= 5000) {
						if (S.Attendant.fetish === "pregnancy") {
							r.push(`${He} can't keep ${his} ${hasBothArms(S.Attendant) ? `hands` : `hand`} off ${slave.slaveName}'s pregnancy, but ${he2} doesn't mind ${his2} full belly being fondled.`);
							S.Attendant.fetishStrength += 4;
							S.Attendant.fetishStrength += 4;
						} else {
							r.push(`${He} does ${his} best to accommodate ${slave.slaveName}'s pregnancy and to make sure the mother-to-be is happy and comfortable.`);
							if (random(1, 100) > 65 && S.Attendant.fetish === "none") {
								r.push(`After massaging ${slave.slaveName}'s growing belly multiple times, ${S.Attendant.slaveName} begins to find ${himself} fantasizing about being swollen with life too.`);
								S.Attendant.fetish = "pregnancy";
							}
						}
						slave.devotion += 3;
						slave.trust += 3;
					} else {
						if (S.Attendant.fetish === "pregnancy") {
							r.push(`${He} can't help but pester ${slave.slaveName} with questions about ${his2} famous pregnancy, limiting ${his2} ability to truly relax.`);
							slave.devotion += 1;
							slave.trust += 1;
						} else if (canGetPregnant(slave)) {
							r.push(`${He} does ${his} best to encourage ${slave.slaveName}'s fertilization by performing any fertility boosting actions ${he} can.`);
							slave.devotion += 3;
							slave.trust += 3;
						}
					}
			}
			if (
				!attendantUsedCure &&
				(S.Attendant.intelligence + S.Attendant.intelligenceImplant > 15) &&
				(S.Attendant.intelligence + S.Attendant.intelligenceImplant + softenFlawBonus) > random(1, 200) &&
				(V.spaFix === 0)
			) {
				if (slave.behavioralFlaw !== "none") {
					SoftenBehavioralFlaw(slave);
					attendantUsedCure = true;
					r.push(`${S.Attendant.slaveName} works carefully with ${slave.slaveName}, and successfully`);
					r.push(App.UI.DOM.makeElement("span", `softens ${his2} behavioral flaw`, "green"));
					r.push(`into an appealing quirk.`);
				} else if (slave.sexualFlaw !== "none") {
					SoftenSexualFlaw(slave);
					attendantUsedCure = true;
					r.push(`${S.Attendant.slaveName} works carefully with ${slave.slaveName}, and successfully`);
					r.push(App.UI.DOM.makeElement("span", `softens ${his2} sexual flaw`, "green"));
					r.push(`into an appealing quirk.`);
				}
			}
			if (slave.lactation > 0) {
				r.push(`${S.Attendant.slaveName} takes care to keep ${slave.slaveName}'s breasts comfortably drained.`);
				slave.lactationDuration = 2;
				slave.boobs -= slave.boobsMilk;
				slave.boobsMilk = 0;
			}
			App.Events.addNode(el, r, "div", "indent");
		}

		if (slaves.length < V.spa) {
			const seed = random(1, 10) + ((V.spa - slaves.length) * (random(150, 170) + (idleBonus * 10)));
			cashX(seed, "spa", S.Attendant);
			r = [];
			r.push(`Since ${he} doesn't have enough slaves to occupy all ${his} time, the spa takes in citizens' slaves on a contract basis and ${he} helps them too, earning <span class="yellowgreen"> ${cashFormat(seed)}.</span>`);
			if (V.arcologies[0].FSHedonisticDecadence > 0 && slaves.length === 0) {
				r.push(`Society <span class="green">loves</span> being allowed to lounge in your spa, greatly advancing your laid back culture.`);
				FutureSocieties.Change("Hedonistic", 2);
			}
			App.Events.addNode(el, r, "div", "indent");
		}
	}

	if (slaves.length > 0) {
		r = [];
		if (slaves.length > 1) {
			r.push(`There are ${slaves.length} slaves`);
		} else {
			r.push(`There is one slave`);
		}
		r.push(`resting and recuperating in the spa.`);
		App.Events.addNode(el, r, "p", ["indent", "bold"]);
	}

	if (S.Attendant) {
		const slave = S.Attendant;
		tired(slave);
		/* apply following SA passages to facility leader */
		if (V.showEWD !== 0) {
			const attendantEntry = App.UI.DOM.appendNewElement("div", el, '', "slave-report");
			App.SlaveAssignment.appendSlaveArt(attendantEntry, slave);
			attendantEntry.append(App.UI.favoriteToggle(slave), " ");
			App.Events.addNode(
				attendantEntry,
				[
					App.UI.DOM.makeElement("span", SlaveFullName(slave), "slave-name"),
					`is serving as the Attendant in ${V.spaName}`,
					App.SlaveAssignment.standardSlaveReport(slave, false),
				]
			);
		} else {
			App.SlaveAssignment.standardSlaveReport(slave, true);
		}
	}

	for (const slave of slaves) {
		const {He, he, his} = getPronouns(slave);
		slave.devotion += devBonus;
		improveCondition(slave, 5 + healthBonus);
		if (slave.health.condition < -80) {
			improveCondition(slave, 15);
		} else if (slave.health.condition < -40) {
			improveCondition(slave, 10);
		} else if (slave.health.condition < 0) {
			improveCondition(slave, 5);
		}
		if (V.spaUpgrade === 1 && slave.health.condition < 100) {
			improveCondition(slave, normalRandInt(8));
		}
		if (slave.devotion < 60 && slave.trust < 60) {
			slave.devotion++;
			slave.trust++;
		} else if ((slave.trust < 40)) {
			slave.trust += 10;
		} else if ((slave.devotion < 40)) {
			slave.devotion += 10;
		}
		switch (V.spaDecoration) {
			case "Chattel Religionist":
			case "Chinese Revivalist":
				slave.rules.living = "normal";
				break;
			case "Degradationist":
				slave.rules.living = "spare";
				break;
			default:
				slave.rules.living = "luxurious";
		}
		if (slave.health.condition >= 20 && slave.health.tired <= 30 && slave.trust > 60 && slave.devotion > 60 && slave.fetish !== "mindbroken" && slave.sexualFlaw === "none" && slave.behavioralFlaw === "none") {
			const slaveFixed = App.UI.DOM.makeElement("p");
			App.Events.addNode(
				slaveFixed,
				[
					App.UI.DOM.makeElement("span", slave.slaveName, "slave-name"),
					`is feeling well enough to leave ${V.spaName}, `
				]
			);
			r = [];
			if (V.assignmentRecords[slave.ID]) {
				const oldJob = V.assignmentRecords[slave.ID];
				assignJobSafely(slave, oldJob);
				if (slave.choosesOwnAssignment === 1) {
					r.push(`and ${he} is resting before choosing another task.`);
				} else if (slave.assignment === "rest") {
					if (oldJob !== "rest") {
						r.push(`and since ${he} was unable to return to ${his} old task to ${oldJob}, ${his} assignment has defaulted to rest.`);
					} else {
						r.push(`so ${he} has returned to rest.`);
					}
				} else {
					r.push(`so ${he} goes back to ${slave.assignment}.`);
				}
			} else {
				r.push(`so ${his} assignment has defaulted to rest.`);
				removeJob(slave, "rest in the spa");
			}
			App.Events.addNode(slaveFixed, r, "span", "noteworthy");
			el.append(slaveFixed);
			restedSlaves++;
			restedSlave = slave;
			continue;
		}

		if (V.showEWD !== 0) {
			const slaveEntry = App.UI.DOM.appendNewElement("div", el, '', "slave-report");
			App.SlaveAssignment.appendSlaveArt(slaveEntry, slave);
			slaveEntry.append(App.UI.favoriteToggle(slave), " ");
			r = [];
			r.push(App.UI.DOM.makeElement("span", SlaveFullName(slave), "slave-name"));
			if (slave.choosesOwnAssignment === 2) {
				r.push(App.SlaveAssignment.choosesOwnJob(slave));
			} else {
				r.push(`is resting in ${V.spaName}.`);
			}
			App.Events.addNode(slaveEntry, r);

			r = [];
			r.push(He);
			r.push(App.SlaveAssignment.rest(slave));

			if (slave.fetish === "mindbroken") {
				r.push(`${He} remains in the Spa, completely mindbroken.`);
			} else if (slave.sexualFlaw !== "none" || slave.behavioralFlaw !== "none") {
				r.push(`${He} remains in the Spa, stubborn in ${his} flaw.`);
			} else if (slave.trust < 60 || slave.devotion < 60) {
				r.push(`${He} remains in the Spa, as ${he} is still learning to accept life as a slave.`);
			} else if (slave.health.condition < 20) {
				r.push(`${He} remains in the Spa, as ${he} is benefiting from its healing properties.`);
			} else if (slave.health.tired > 30) {
				r.push(`${He} remains in the Spa, continuing to soak away ${his} fatigue.`);
			}
			App.Events.addNode(slaveEntry, r, "div", "indent");
			slaveEntry.append(App.SlaveAssignment.standardSlaveReport(slave, false));
		} else {
			// discard return values silently
			App.SlaveAssignment.choosesOwnJob(slave);
			App.SlaveAssignment.standardSlaveReport(slave, true);
		}
	}

	if (restedSlaves > 0) {
		const {he, him} = getPronouns(restedSlave);
		r = [];
		if (restedSlaves === 1) {
			r.push(`One slave has rested until ${he} reached a state of <span class="hotpink">devotion</span> and <span class="mediumaquamarine">trust</span> and will leave the spa before the end of the week.`);
		} else {
			r.push(`${restedSlaves} slaves have rested until they reached a state of <span class="hotpink">devotion</span> and <span class="mediumaquamarine">trust</span> and will leave the spa before the end of the week.`);
		}
		App.Events.addNode(el, r, "p", "indent");
		if (V.spaDecoration !== "standard") {
			r = [];
			r.push(`${capFirstChar(V.spaName)}'s ${V.spaDecoration} atmosphere <span class="hotpink">had an impact on`);
			if (restedSlaves === 1) {
				r.push(`${him} while ${he} was`);
			} else {
				r.push(`them while they were`);
			}
			r.push(`</span> resting.`);
			App.Events.addNode(el, r, "p", "indent");
		}
	}

	return el;
};
