/** Container for temporary variables that must be shared between different elements of the slave assignment report
 * It's still effectively global data (so use sparingly), but with some enforced scoping, and without getting SugarCube involved
 * Should always be null unless App.EndWeek.slaveAssignmentReport is running
 * @type {App.EndWeek.SASharedVariables}
 */
App.EndWeek.saVars = null;

App.EndWeek.SASharedVariables = class {
	/** Initialize - declare members that need to persist *between* slaves here */
	constructor() {
		/** How many slaves can the HG still impregnate? */
		this.HGCum = 0;
		/** How many slaves can the HG still train? */
		this.HGEnergy = 0;
		/** Was the HG's slave successful at helping her? */
		this.HGSlaveSuccess = false;
		/** How much cash bonus is the Madam contributing to her whores? */
		this.madamBonus = 0;
		/** Slave job values */
		this.slaveJobValues = {};
		/** Whore price adjustments (per class) */
		this.whorePriceAdjustment = {};
		/** How many slaves can the designated stud still impregnate? */
		this.StudCum = 0;
		/** How much energy does the player have left to fuck slaves who need it? */
		this.freeSexualEnergy = 0;
		/** How big is the average dick on a slave? */
		this.averageDick = 0;
		/** Who are your subordinate slaves actually assigned to?
		 * @type {Map<number, Array<number>>} - key is sub target, value is list of sub slaves (by ID) assigned to that target
		 */
		this.subSlaveMap = new Map();
		/** Slave art manager */
		this.slaveArt = null;
	}

	/**
	 * Reset slave-specific report variables.  Declare members that need to be reset between slaves here.
	 * @todo call this from all the facility reports (the slave loops are broken up by facility)
	 */
	nextSlave() {
		/** Is this slave's paraphilia satisfied? (1: satisfied, 0: no paraphilia; -1: unsatisfied) */
		this.paraphiliaSatisfied = 0;
		/** A slave with a lot of porn viewers will have a stronger effect on societal norms. This is her multiplier for those effects. */
		this.pornFameBonus = 1;
		/** Used to condense all the possible galactorrhea lactation start points to a single line of text in saLongTermPhysicalEffects. */
		this.inappropriateLactation = 0;
		/** TODO: move V.slaveUsedRest here after saRules is converted, and find others */
	}

	/** Compute shared subslave ratio (subslaves per ordinary slave) */
	get subSlaveRatio() {
		const subSlaves = this.subSlaveMap.get(0);
		const subCount = subSlaves ? subSlaves.length : 0;
		if (V.dormitoryPopulation + V.roomsPopulation <= subCount) {
			return subCount; // avoid negative result or divide by zero
		}
		return subCount / (V.dormitoryPopulation + V.roomsPopulation - subCount);
	}
};
