// FIXME: needs further review

/**
 * @param {App.Entity.SlaveState} slave
 * @returns {DocumentFragment}
 */
App.SlaveAssignment.workTheFarm = function(slave) {
	let frag = document.createDocumentFragment();

	const {he, him, his, He, His} = getPronouns(slave);
	const incomeStats = getSlaveStatisticData(slave, V.facility.farmyard);

	const sexualQuirks = ["perverted", "unflinching"];
	const behavioralQuirks = ["sinful"];
	const fetishes = ["humiliation", "masochist"];

	const slaveApproves = () => sexualQuirks.includes(slave.sexualQuirk) || behavioralQuirks.includes(slave.behavioralQuirk) ||fetishes.includes(slave.fetish);

	const foodAmount = Math.trunc(App.Facilities.Farmyard.foodAmount(slave));

	function fullReport(slave) {
		const report = App.UI.DOM.appendNewElement("div", frag);

		let r = [];

		r.push(intro());
		// r.push(farmer(slave));
		r.push(devotion(slave));
		r.push(muscles(slave));
		r.push(weight(slave));
		r.push(health(slave));
		r.push(sight(slave));
		r.push(hearing(slave));
		r.push(food());

		r.push(slaveShows(slave));
		r.push(longTermEffects(slave));
		r.push(slaveVignettes());

		$(report).append(r.join(' '));
	}

	const intro = () => `${He} works as a farmhand this week.`;

	// function farmer(slave) {
	// TODO: update this with devotion and health effects
	// 	const F = getPronouns(S.Farmer);

	// 	if (S.Farmer) {
	// 		return `${S.Farmer.slaveName} watches over ${him}, making sure that ${he} doesn't slack off and works as hard as ${he} should. ${F.He}'s a tough boss, but a fair one. ${slave.slaveName} benefits from ${F.his} care while working in ${V.farmyardName}.`;
	// 	}
	// }

	function devotion(slave) {
		if (slave.devotion > 50) {
			return `${He}'s so devoted to you that ${he} works harder and produces more food.`;
		} else if (slave.devotion < -50) {
			return `${He}'s so resistant that ${he} doesn't work as hard, and thus produces less food.`;
		} else {
			return `${He} doesn't feel particularly compelled to work hard or slack off and produces an average amount of food.`;
		}
	}

	function health(slave) {
		let r = [];

		r.push(healthCondition(slave));
		r.push(healthIllness(slave));

		return r.join(' ');
	}

	function healthCondition(slave) {
		if (slave.health.condition > 50) {
			return `${His} shining health helps ${him} work harder and longer.`;
		} else if (slave.health.condition < -50) {
			return `${His} poor health impedes ${his} ability to work efficiently.`;
		}
	}

	function healthIllness(slave) {
		let r = [];
		let health = ``;
		let exhaustion = ``;

		if (slave.health.illness > 0 || slave.health.tired > 60) {
			if (slave.health.illness === 1) {
				health = `feeling under the weather`;
			} else if (slave.health.illness === 2) {
				health = `a minor illness`;
			} else if (slave.health.illness === 3) {
				health = `being sick`;
			} else if (slave.health.illness === 4) {
				health = `being very sick`;
			} else if (slave.health.illness === 5) {
				health = `a terrible illness`;
			}

			if (slave.health.tired > 90) {
				exhaustion = `exhaustion`;
			} else if (slave.health.tired > 60) {
				exhaustion = `being tired`;
			}

			r.push(`${He} performed worse this week due to <span class="health dec">${health}${slave.health.illness > 0 && slave.health.tired > 60 ? ` and ` : ``}${exhaustion}.</span>`);

			r.push(tired(slave));
		}

		return r;
	}

	function tired(slave) {
		if (slaveResting(slave)) {
			return `${He} spends reduced hours working the soil in order to <span class="health dec">offset ${his} lack of rest.</span>`;
		} else if (slave.health.tired + 20 >= 90 && !willWorkToDeath(slave)) {
			return `${He} attempts to refuse work due to ${his} exhaustion, but can do little to stop it or the resulting <span class="trust dec">severe punishment.</span> ${He} <span class="devotion dec">purposefully underperforms,</span> choosing ${his} overall well-being over the consequences, <span class="health dec">greatly reducing yields.</span>`;
		} else {
			return `Hours of manual labor quickly add up, leaving ${him} <span class="health dec">physically drained</span> by the end of the day.`;
		}
	}

	function muscles(slave) {
		if (slave.muscles > 50) {
			return `${His} muscular form helps ${him} work better, increasing ${his} productivity.`;
		} else if (slave.muscles < -50) {
			return `${He} is so weak that ${he} is not able to work effectively.`;
		}
	}

	function weight(slave) {
		if (slave.weight > 95) {
			return `${He} is so overweight that ${he} has to stop every few minutes to catch ${his} breath, and so ${his} productivity suffers. `;
		}
	}

	function sight(slave) {
		if (!canSee(slave)) {
			return `${His} blindness makes it extremely difficult for ${him} to work, severely limiting ${his} production.`;
		} else if (!canSeePerfectly(slave)) {
			return `${His} nearsightedness makes it harder for ${him} to work as hard as ${he} otherwise would.`;
		}
	}

	function hearing(slave) {
		if (slave.hears === -1) {
			return `${He} is hard-of-hearing, which gets in the way of ${his} work whenever ${he} misses directions${S.Farmer ? ` from ${S.Farmer.slaveName}` : ``}.`;
		} else if (slave.hears < -1) {
			return `${He} is deaf, which gets in the way of ${his} work whenever ${he} misses directions${S.Farmer ? ` from ${S.Farmer.slaveName}` : ``}.`;
		}
	}

	function food() {
		const fsGain = 0.0001 * foodAmount;

		FutureSocieties.DecorationBonus(V.farmyardDecoration, fsGain);

		if (V.foodMarket) {
			return `As a result, ${he} produces <span class="chocolate">${massFormat(foodAmount)}</span> of food over the week.`;
		}
	}

	// Open Food Production

	if (V.foodMarket) {
		V.food += foodAmount;
		V.foodTotal += foodAmount;
		incomeStats.food += foodAmount;
	}

	// Close Food Production

	// Open Shows

	function slaveShows(slave) {
		if (V.farmyardShows) {
			return App.Facilities.Farmyard.putOnShows(slave);
		}
	}

	// Close Shows

	// Open Long-Term Effects

	function longTermEffects(slave) {
		let r = [];

		if (slave.fetishKnown && slaveApproves || slave.energy > 95) {
			if (V.farmyardShows) {
				if (V.seeBestiality) {
					r.push(`Getting fucked by animals is the perfect job for ${him}, as far as ${he} can tell. <span class="devotion inc">${He} is happy</span> to spend ${his} days being utterly degraded.`);
					slave.devotion += 1;
				} else {
					r.push(`${He} loves putting on shows with animals, and as far as ${he} can tell, it's the perfect job for ${him}. It isn't as degrading as ${he} would like, but <span class="devotion inc">${he} is happy nonetheless.</span>`);
					slave.devotion += 2;
				}
			}

			slave.need = 0;
		}

		return r;
	}

	// Close Long-Term Effects

	// Open Vignettes

	function slaveVignettes() {
		if (V.showVignettes) {
			const vignette = GetVignette(slave);

			let r = [];

			r.push(`<span class="story-label">This week</span> ${vignette.text}`);

			if (vignette.type === "cash") {
				r.push(vignetteCash(vignette));
			}

			if (vignette.type === "devotion") {
				r.push(vignetteDevotion(vignette));
			}

			if (vignette.type === "trust") {
				r.push(vignetteTrust(vignette));
			}

			if (vignette.type === "health") {
				r.push(vignetteHealth(vignette));
			}

			if (vignette.type === "rep") {
				r.push(vignetteReputation(vignette));
			}

			return r.join(' ');
		}
	}

	function vignetteCash(vignette) {
		const FResultNumber = FResult(slave);
		const cash = Math.trunc(FResultNumber * vignette.effect);

		incomeStats.income += cash;

		if (vignette.effect > 0) {
			cashX(cash, "slaveAssignmentFarmyardVign", slave);

			return `<span class="yellowgreen">making you an extra ${cashFormat(cash)}.</span>`;
		} else if (vignette.effect < 0) {
			cashX(forceNeg(cash), "slaveAssignmentFarmyardVign", slave);

			return `<span class="reputation dec">losing you ${cashFormat(Math.abs(cash))}.</span>`;
		} else {
			return `an incident without lasting effect.`;
		}
	}

	function vignetteDevotion(vignette) {
		slave.devotion += 1 * vignette.effect;

		if (vignette.effect > 0) {
			if (slave.devotion > 50) {
				return `<span class="devotion inc">increasing ${his} devotion to you.</span>`;
			} else if (slave.devotion >= 20) {
				return `<span class="devotion inc">increasing ${his} acceptance of you.</span>`;
			} else if (slave.devotion >= -20) {
				return `<span class="devotion inc">reducing ${his} dislike of you.</span>`;
			} else {
				return `<span class="devotion inc">reducing ${his} hatred of you.</span>`;
			}
		} else if (vignette.effect < 0) {
			if (slave.devotion > 50) {
				return `<span class="devotion dec">reducing ${his} devotion to you.</span>`;
			} else if (slave.devotion >= 20) {
				return `<span class="devotion dec">reducing ${his} acceptance of you.</span>`;
			} else if (slave.devotion >= -20) {
				return `<span class="devotion dec">increasing ${his} dislike of you.</span>`;
			} else {
				return `<span class="devotion dec">increasing ${his} hatred of you.</span>`;
			}
		} else {
			return `an incident without lasting effect.`;
		}
	}

	function vignetteTrust(vignette) {
		slave.trust += 1 * vignette.effect;

		if (vignette.effect > 0) {
			if (slave.trust > 20) {
				return `<span class="trust inc">increasing ${his} trust in you.</span>`;
			} else if (slave.trust >= -20) {
				return `<span class="trust inc">reducing ${his} fear of you.</span>`;
			} else {
				return `<span class="trust inc">reducing ${his} terror of you.</span>`;
			}
		} else if (vignette.effect < 0) {
			if (slave.trust > 20) {
				return `<span class="trust dec">reducing ${his} trust in you.</span>`;
			} else if (slave.trust >= -20) {
				return `<span class="trust dec">increasing ${his} fear of you.</span>`;
			} else {
				return `<span class="trust dec">increasing ${his} terror of you.</span>`;
			}
		} else {
			return `an incident without lasting effect.`;
		}
	}

	function vignetteHealth(vignette) {
		if (vignette.effect > 0) {
			improveCondition(slave, 2 * vignette.effect);

			return `<span class="reputation inc">improving ${his} health.</span>`;
		} else if (vignette.effect < 0) {
			healthDamage(slave, 2 * vignette.effect);

			return `<span class="reputation dec">affecting ${his} health.</span>`;
		} else {
			return `an incident without lasting effect.`;
		}
	}

	function vignetteReputation(vignette) {
		const FResultNumber = FResult(slave);

		repX(Math.trunc(FResultNumber * vignette.effect * 0.1), "vignette", slave);
		incomeStats.rep += Math.trunc(FResultNumber * vignette.effect * 0.1);

		if (vignette.effect > 0) {
			return `<span class="reputation inc">gaining you a bit of reputation.</span>`;
		} else if (vignette.effect < 0) {
			return `<span class="reputation dec">losing you a bit of reputation.</span>`;
		} else {
			return `an incident without lasting effect.`;
		}
	}

	// Close Vignettes

	fullReport(slave);

	return frag;
};
