App.Facilities.Pit.fight = function(lethal) {
	const frag = new DocumentFragment();

	/** @type {number[]} */
	const available = [...new Set(V.pit.fighterIDs)];
	/** @type {number[]} */
	const fighters = [];

	V.nextButton = "Continue";
	V.nextLink = "Scheduled Event";
	V.returnTo = "Scheduled Event";

	V.pit.fought = true;

	if (V.pit.slaveFightingBodyguard) {	// slave is fighting bodyguard for their life
		fighters.push(S.Bodyguard.ID, V.pit.slaveFightingBodyguard);
	} else {
		if (available.length > 0) {
			// first fighter
			if (S.Bodyguard && V.pit.bodyguardFights) {
				available.delete(S.Bodyguard.ID);
				fighters.push(S.Bodyguard.ID);
			} else {
				fighters.push(available.pluck());
			}

			// second fighter
			if (available.length > 0 && !V.pit.animal) {
				fighters.push(available.pluck());
			}
		} else {
			throw new Error(`Pit fight triggered with ${V.pit.fighterIDs.length} fighters.`);	// should technically never be triggered
		}
	}

	frag.appendChild(lethal ?
		App.Facilities.Pit.fight.lethal(fighters) :
		App.Facilities.Pit.fight.nonlethal(fighters)
	);

	if (V.debugMode) {
		console.log(`Available:\n${available}\nFighters:\n${fighters}`);
	}

	return frag;
};
