App.Facilities.Farmyard.farmyard = function() {
	const frag = new DocumentFragment();

	const introDiv = document.createElement("div");
	const expandDiv = document.createElement("div");
	const menialsDiv = document.createElement("div");
	const rulesDiv = document.createElement("div");
	const upgradesDiv = document.createElement("div");
	const animalsDiv = document.createElement("div");

	V.nextButton = "Back to Main";
	V.nextLink = "Main";
	V.returnTo = "Farmyard";
	V.encyclopedia = "Farmyard";

	frag.append(
		intro(),
		expand(),
		menials(),
		rules(),
		upgrades(),
		animals()
	);

	App.UI.DOM.appendNewElement("div", frag, App.UI.SlaveList.stdFacilityPage(App.Entity.facilities.farmyard), "farmyard-slaves");

	App.UI.SlaveList.ScrollPosition.restore();

	frag.appendChild(App.Facilities.rename(App.Entity.facilities.farmyard, () => {
		App.UI.DOM.replace(introDiv, intro);
		App.UI.DOM.replace(expandDiv, expand);
		App.UI.DOM.replace(menialsDiv, menials);
		App.UI.DOM.replace(rulesDiv, rules);
		App.UI.DOM.replace(upgradesDiv, upgrades);
		App.UI.DOM.replace(animalsDiv, animals);
	}));

	return frag;



	function intro() {
		introDiv.classList.add("farmyard-intro", "scene-intro");

		const desc = App.UI.DOM.appendNewElement("div", introDiv, `${capFirstChar(V.farmyardName)} is an oasis of growth in the midst of the jungle of steel and concrete that is ${V.arcologies[0].name}. Animals are kept in pens, tended to by your slaves, while ${V.farmyardUpgrades.hydroponics
			? `rows of hydroponics equipment`
			: `makeshift fields`} grow crops. `);
		const link = App.UI.DOM.makeElement("div", null, "indent");

		const count = App.Entity.facilities.farmyard.totalEmployeesCount;

		switch (V.farmyardDecoration) {
			case "Roman Revivalist":
				desc.append(`Its red tiles and white stone walls are the very picture of a Roman farm villa's construction, as are the marble statues and reliefs. Saturn and Ceres look over the prosperity of the fields${V.seeBestiality ? `. Mercury watches over the health of the animals, and Feronia ensures strong litters in your slaves.` : `, and Mercury watches over the health of the animals.`} The slaves here are all looked after well, as they have one of the most important jobs in ${V.arcologies[0].name}.`);
				break;
			case "Neo Imperialist":
				desc.append(`Its high-tech, sleek black design invocates an embracement of the future, tempered by the hanging banners displaying your family crest as the rightful lord and master of these farms. Serf-like peasants work tirelessly in the fields, both to grow crops and oversee the slaves beneath them. Despite the harsh nature of the fieldwork, the slaves here are all looked after well, as they have one of the most important jobs in ${V.arcologies[0].name}.`);
				break;
			case "Aztec Revivalist":
				desc.append(`It can't completely recreate the floating farms in the ancient Aztec fashion, but it comes as close as it can, shallow pseudo-canals dividing each field into multiple sections. Smooth stone and colorful murals cover the walls, depicting bloody stories of gods and mortals alike.`);
				break;
			case "Egyptian Revivalist":
				desc.append(`It does its best to capture the wide open nature of ancient Egyptian farms, including mimicking the irrigation systems fed by the Nile. The stone walls are decorated with murals detailing its construction and your prowess in general, ${V.seeBestiality ? `with animal-bloated slaves featured prominently.` : `hieroglyphs spelling out a volumes of praise.`}`);
				break;
			case "Edo Revivalist":
				desc.append(`It does its best to mimic the rice patties and thatch roofed buildings of the Edo period despite the wide variety of crops tended by various slaves. Not every crop can thrive in flooded fields, but the ones that can take advantage of your attention to detail.`);
				break;
			case "Arabian Revivalist":
				desc.append(`Large plots of olive trees and date palms line the outer edges of the main crop area, while a combination of wheat, flax, and barley occupies the interior space. Irrigation canals snake through the area, ensuring every inch of cropland is well-watered.`);
				break;
			case "Chinese Revivalist":
				desc.append(`It does its best to capture the terraces that covered the ancient Chinese hills and mountains, turning every floor into ribbons of fields following a slight incline. Slaves wade through crops that can handle flooding and splash through the irrigation of the others when they aren't tending to${V.seeBestiality ? ` or breeding with` : ``} your animals.`);
				break;
			case "Chattel Religionist":
				desc.append(`It runs like a well oiled machine, slaves bent in humble service as they tend crops grown on the Prophet's command, or see to the animals' needs. Their clothing is tucked up and out of the way as they see to their tasks, keeping them clean as they work ${V.seeBestiality ? `around animal-bloated bellies ` : ``}as divine will dictates.`);
				break;
			case "Degradationist":
				desc.append(`It is constructed less as a converted warehouse and more as something to visit, allowing guests to enjoy the spectacle of slaves ${V.seeBestiality ? `being pounded by eager animals` : `elbow deep in scrubbing animal waste`} to their satisfaction.`);
				break;
			case "Repopulation Focus":
				desc.append(`It teems with life, both in the belly of every animal and the belly of every slave, though the latter makes tending the fields difficult. They're ordered to take care, as they carry the future ${V.seeBestiality ? `of this farm` : `of the arcology`} in their bellies.`);
				break;
			case "Eugenics":
				desc.append(`It holds a wide variety of crops and animals, but the best of the best is easy to find. They're set apart from the others, given only the best care and supplies${V.seeBestiality ? ` and bred with only the highest quality slaves` : ``}, while the sub-par stock is neglected off to the side.`);
				break;
			case "Asset Expansionist":
				desc.append(`It is not easy to look after animals and till fields with such enormous body parts, but your slaves are diligent regardless, working hard to provide food and livestock for the arcology.`);
				break;
			case "Transformation Fetishist":
				// desc.append(`TODO:`);
				break;
			case "Gender Radicalist":
				// desc.append(`TODO:`);
				break;
			case "Gender Fundamentalist":
				// desc.append(`TODO:`);
				break;
			case "Physical Idealist":
				desc.append(`Its animals are in exceptional shape, their coats unable to hide how muscular they are, requiring your slaves to be equally toned to control them. There's plenty of space for their exercise as well${V.seeBestiality ? ` and an abundance of curatives for the slaves full of their fierce, kicking offspring` : ``}.`);
				break;
			case "Supremacist":
				desc.append(`It is a clean and orderly operation, stables and cages mucked by a multitude of inferior slaves, along with grooming your animals and harvesting your crops.`);
				break;
			case "Subjugationist":
				desc.append(`It is a clean and orderly operation, stables and cages mucked by a multitude of ${V.arcologies[0].FSSubjugationistRace} slaves, while the others are tasked with grooming your animals and harvesting your crops.`);
				break;
			case "Paternalist":
				desc.append(`It's full of healthy animals, crops, and slaves, the former's every need diligently looked after by the latter. The fields flourish to capacity under such care, and the animals give the distinct impression of happiness${V.seeBestiality ? ` — some more than others if the growing bellies of your slaves are anything to go by, the only indication that such rutting takes place` : ``}.`);
				break;
			case "Pastoralist":
				// desc.append(`TODO:`);
				break;
			case "Maturity Preferentialist":
				// desc.append(`TODO:`);
				break;
			case "Youth Preferentialist":
				// desc.append(`TODO:`);
				break;
			case "Body Purist":
				// desc.append(`TODO:`);
				break;
			case "Slimness Enthusiast":
				desc.append(`It features trim animals and slaves alike, not a pound of excess among them. The feed for both livestock and crops are carefully maintained to ensure optimal growth without waste, letting them flourish without being weighed down.`);
				break;
			case "Hedonistic":
				desc.append(`It features wider gates and stalls, for both the humans visiting or tending the occupants, and the animals starting to mimic their handlers${V.seeBestiality ? ` and company` : ``}, with plenty of seats along the way.`);
				break;
			default:
				desc.append(`It is very much a converted warehouse still, sectioned off in various 'departments'${V.farmyardUpgrades.machinery ? ` with machinery placed where it can be` : V.farmyardUpgrades.hydroponics ? ` and plumbing for the hydroponics system running every which way` : ``}.`);
				break;
		}

		if (count > 2) {
			desc.append(` ${capFirstChar(V.farmyardName)} is bustling with activity. Farmhands are hurrying about, on their way to feed animals and maintain farming equipment.`);
		} else if (count) {
			desc.append(` ${capFirstChar(V.farmyardName)} is working steadily. Farmhands are moving about, looking after the animals and crops.`);
		} else if (S.Farmer) {
			desc.append(` ${S.Farmer.slaveName} is alone in ${V.farmyardName}, and has nothing to do but look after the animals and crops.`);
		} else {
			desc.append(` ${capFirstChar(V.farmyardName)} is empty and quiet.`);
		}

		link.append(App.UI.DOM.passageLink(`Decommission ${V.farmyardName}`, "Main", () => {
			if (V.farmMenials) {
				V.menials += V.farmMenials;
				V.farmMenials = 0;
			}

			V.farmyardName = "the Farmyard";
			V.farmyard = 0;
			V.farmyardDecoration = "standard";

			V.farmMenials = 0;
			V.farmMenialsSpace = 0;

			V.farmyardShows = 0;
			V.farmyardBreeding = 0;
			V.farmyardCrops = 0;

			V.farmyardKennels = 0;
			V.farmyardStables = 0;
			V.farmyardCages = 0;

			if (V.pit) {
				V.pit.animal = null;
			}

			V.farmyardUpgrades = {
				pump: 0,
				fertilizer: 0,
				hydroponics: 0,
				machinery: 0,
				seeds: 0
			};

			clearAnimalsPurchased();
			App.Arcology.cellUpgrade(V.building, App.Arcology.Cell.Manufacturing, "Farmyard", "Manufacturing");
		}));

		desc.append(link);
		introDiv.appendChild(desc);

		return introDiv;
	}

	function expand() {
		expandDiv.classList.add("farmyard-expand");

		const desc = document.createElement("div");
		const link = App.UI.DOM.makeElement("div", null, "indent");
		const note = App.UI.DOM.makeElement("span", null, "note");
		const cost = App.UI.DOM.makeElement("span", null, "yellowgreen");

		const upgradeCost = Math.trunc(V.farmyard * 1000 * V.upgradeMultiplierArcology);
		const farmhands = App.Entity.facilities.farmyard.totalEmployeesCount;

		cost.append(cashFormat(upgradeCost));

		desc.append(`It can support ${V.farmyard} farmhands. Currently there ${farmhands === 1 ? `is` : `are`} ${farmhands} ${farmhands === 1 ? `farmhand` : `farmhands`} in ${V.farmyardName}. `);
		note.append(` Costs `, cost, ` and will increase upkeep costs`);

		link.append(App.UI.DOM.passageLink(`Expand ${V.farmyardName}`, "Farmyard", () => {
			cashX(forceNeg(upgradeCost), "capEx");
			V.farmyard += 5;
			V.PC.skill.engineering += .1;
		}));

		link.append(note);
		desc.append(link);
		expandDiv.appendChild(desc);

		if (App.Entity.facilities.farmyard.totalEmployeesCount) {
			App.UI.DOM.appendNewElement("div", expandDiv, removeFacilityWorkers("farmyard"), "indent");
		}

		return expandDiv;
	}

	function menials() {
		menialsDiv.classList.add("farmyard-menials");

		menialsDiv.append(transferMenials(), buyMenials(), houseMenials());

		return menialsDiv;
	}

	function transferMenials() {
		const frag = new DocumentFragment();

		const links = [];
		const linksDiv = App.UI.DOM.makeElement("div", null, "indent");

		const menials = V.menials;
		const farmMenials = V.farmMenials;
		const farmMenialsSpace = V.farmMenialsSpace;

		if (farmMenials) {
			frag.append(`Assigned to ${V.farmyardName} ${farmMenials === 1 ? `is` : `are`} ${farmMenials} menial ${farmMenials === 1 ? `slave` : `slaves`}, working to produce as much food for your arcology as they can. `);
		}

		if (farmMenialsSpace) {
			frag.append(`You ${menials ? `own ${num(menials)}` : `don't own any`} free menial slaves. ${capFirstChar(V.farmyardName)} can house ${farmMenialsSpace} menial slaves total, with ${farmMenialsSpace - farmMenials} free spots. `);
		}

		if (farmMenialsSpace && farmMenials < farmMenialsSpace) {
			if (menials) {
				links.push(App.UI.DOM.passageLink("Transfer in a menial slave", "Farmyard", () => {
					V.menials--;
					V.farmMenials++;
				}));
			}

			if (menials >= 10 && farmMenials <= farmMenialsSpace - 10) {
				links.push(App.UI.DOM.passageLink("Transfer in 10 menial slaves", "Farmyard", () => {
					V.menials -= 10;
					V.farmMenials += 10;
				}));
			}

			if (menials >= 100 && farmMenials <= farmMenialsSpace - 100) {
				links.push(App.UI.DOM.passageLink("Transfer in 100 menial slaves", "Farmyard", () => {
					V.menials -= 100;
					V.farmMenials += 100;
				}));
			}

			if (menials) {
				links.push(App.UI.DOM.passageLink("Transfer in all free menial slaves", "Farmyard", () => {
					if (menials > farmMenialsSpace - farmMenials) {
						V.menials -= farmMenialsSpace - farmMenials;
						V.farmMenials = farmMenialsSpace;
					} else {
						V.farmMenials += menials;
						V.menials = 0;
					}
				}));
			}
		} else if (!farmMenialsSpace) {
			frag.append(`${capFirstChar(V.farmyardName)} cannot currently house any menial slaves. `);
		} else {
			frag.append(`${capFirstChar(V.farmyardName)} has all the menial slaves it can currently house assigned to it. `);
		}

		if (farmMenials) {
			links.push(App.UI.DOM.passageLink("Transfer out all menial slaves", "Farmyard", () => {
				V.menials += farmMenials;
				V.farmMenials = 0;
			}));
		}

		linksDiv.append(App.UI.DOM.generateLinksStrip(links));
		frag.append(linksDiv);


		return frag;
	}

	function buyMenials() {
		const frag = new DocumentFragment();

		const links = [];
		const linksDiv = App.UI.DOM.makeElement("div", null, "indent");

		const menials = V.menials;
		const farmMenials = V.farmMenials;
		const farmMenialsSpace = V.farmMenialsSpace;
		const popCap = menialPopCap();
		const bulkMax = popCap.value - menials - V.fuckdolls - V.menialBioreactors;

		const menialPrice = Math.trunc(menialSlaveCost());
		const maxMenials = Math.trunc(Math.clamp(V.cash / menialPrice, 0, bulkMax));

		if (farmMenialsSpace) {
			if (bulkMax > 0 || V.menials + V.fuckdolls + V.menialBioreactors === 0) {
				links.push(App.UI.DOM.passageLink("Buy ", "Farmyard", () => {
					V.menials++;
					V.menialSupplyFactor--;
					cashX(forceNeg(menialPrice), "farmyard");
				}));

				links.push(App.UI.DOM.passageLink("(x10)", "Farmyard", () => {
					V.menials += 10;
					V.menialSupplyFactor -= 10;
					cashX(forceNeg(menialPrice * 10), "farmyard");
				}));

				links.push(App.UI.DOM.passageLink("(x100)", "Farmyard", () => {
					V.menials += 100;
					V.menialSupplyFactor -= 100;
					cashX(forceNeg(menialPrice * 100), "farmyard");
				}));

				links.push(App.UI.DOM.passageLink("(max)", "Farmyard", () => {
					V.menials += maxMenials;
					V.menialSupplyFactor -= maxMenials;
					cashX(forceNeg(maxMenials * menialPrice), "farmyard");
				}));
			}
		}

		if (farmMenials) {
			linksDiv.append(App.UI.DOM.generateLinksStrip(links));
			frag.append(linksDiv);
		}

		return frag;
	}

	function houseMenials() {
		const frag = new DocumentFragment();

		const desc = document.createElement("div");
		const link = App.UI.DOM.makeElement("div", null, "indent");
		const note = App.UI.DOM.makeElement("span", null, "note");
		const cost = App.UI.DOM.makeElement("span", null, "yellowgreen");

		const unitCost = Math.trunc(1000 * V.upgradeMultiplierArcology);

		cost.append(cashFormat(unitCost));

		if (V.farmMenialsSpace < 500) {
			desc.append(`There is enough room in ${V.farmyardName} to build housing, enough to give ${V.farmMenialsSpace + 100} menial slaves a place to sleep and relax. `);
			note.append(` Costs `, cost, ` and will increase upkeep costs`);

			link.append(App.UI.DOM.passageLink("Build a new housing unit", "Farmyard", () => {
				cashX(forceNeg(unitCost), "farmyard");
				V.farmMenialsSpace += 100;
			}), note);

			desc.append(link);
			frag.append(desc);
		}

		return frag;
	}

	function rules() {
		rulesDiv.classList.add("farmyard-rules");

		if (App.Entity.facilities.farmyard.employeesIDs().size > 0) {	// TODO: redo this with V.farmyardShowgirls
			if (V.farmyardShows && (V.canine || V.hooved || V.feline)) {
				const rule = makeRule(
					['Slaves', 'are putting on shows with animals'],
					'are',
					"End shows",
					[],
					["farmyardShows", "farmyardBreeding", "farmyardRestraints"]
				);

				rulesDiv.append(rule);

				if (V.seeBestiality) {
					if (V.farmyardBreeding) {
						const rule = makeRule(
							['Slaves', 'are being bred with animals'],
							'are',
							"End breeding",
							["farmyardShows"],
							["farmyardBreeding", "farmyardRestraints"]
						);

						rulesDiv.append(rule);

						if (V.farmyardRestraints) {
							const rule = makeRule(
								'are being restrained',
								'All of the slaves',
								"Restrain only disobedient slaves",
								["farmyardShows", "farmyardBreeding"],
								["farmyardRestraints"]
							);

							rulesDiv.append(rule);
						} else {
							const rule = makeRule(
								'are being restrained',
								'Only disobedient slaves',
								"Restrain all slaves",
								["farmyardShows", "farmyardBreeding", "farmyardRestraints"],
								[]
							);

							rulesDiv.append(rule);
						}
					} else {
						const rule = makeRule(
							['Slaves', 'being bred with animals'],
							'are not',
							"Begin breeding",
							["farmyardShows", "farmyardBreeding"],
							["farmyardRestraints"]
						);

						rulesDiv.append(rule);
					}
				}
			} else {
				const rule = makeRule(
					['Slaves', 'putting on shows with animals'],
					'are not',
					"Begin shows",
					["farmyardShows"],
					["farmyardBreeding", "farmyardRestraints"]
				);

				rulesDiv.append(rule);
			}
		}

		/**
		 * Creates a new rule button
		 * @param {string|string[]} descText The base description for the rule
		 * @param {string} boldText The part in bold
		 * @param {string} linkText The link text
		 * @param {string[]} enabled Variables to be set to 1
		 * @param {string[]} disabled Variables to be set to 0
		 */
		function makeRule(descText, boldText, linkText, enabled, disabled) {
			const frag = new DocumentFragment();

			const desc = document.createElement("div");
			const bold = App.UI.DOM.makeElement("span", boldText, "bold");
			const link = document.createElement("span");

			if (Array.isArray(descText)) {
				desc.append(`${descText[0]} `, bold, ` ${descText[1]}. `);
			} else {
				desc.append(bold, ` ${descText}. `);
			}

			link.append(App.UI.DOM.passageLink(linkText, "Farmyard", () => {
				enabled.forEach(i => V[i] = 1);
				disabled.forEach(i => V[i] = 0);
			}));

			desc.append(link);
			frag.append(desc);

			return frag;
		}

		return rulesDiv;
	}

	function upgrades() {
		const farmyardUpgrades = V.farmyardUpgrades;

		const pumpCost = Math.trunc(5000 * V.upgradeMultiplierArcology);
		const fertilizerCost = Math.trunc(10000 * V.upgradeMultiplierArcology);
		const hydroponicsCost = Math.trunc(20000 * V.upgradeMultiplierArcology);
		const seedsCost = Math.trunc(25000 * V.upgradeMultiplierArcology);
		const machineryCost = Math.trunc(50000 * V.upgradeMultiplierArcology);

		if (!farmyardUpgrades.pump) {
			const desc = document.createElement("div");
			const upgrade = createUpgrade(
				"Upgrade the water pump",
				pumpCost,
				'slightly decreases upkeep costs',
				"pump"
			);

			desc.append(`${capFirstChar(V.farmyardName)} is currently using the basic water pump that it came with.`);

			upgradesDiv.append(desc, upgrade);
		} else {
			const desc = document.createElement("div");

			desc.append(`The water pump in ${V.farmyardName} is a more efficient model, slightly improving the amount of crops it produces.`);

			upgradesDiv.append(desc);

			if (!farmyardUpgrades.fertilizer) {
				const upgrade = createUpgrade(
					"Use a higher-quality fertilizer",
					fertilizerCost,
					'moderately increases crop yield and slightly increases upkeep costs',
					"fertilizer"
				);

				upgradesDiv.append(upgrade);
			} else {
				const desc = document.createElement("div");

				desc.append(`${capFirstChar(V.farmyardName)} is using a higher-quality fertilizer, moderately increasing the amount of crops it produces and raising slightly raising upkeep costs.`);

				upgradesDiv.append(desc);

				if (!farmyardUpgrades.hydroponics) {
					const upgrade = createUpgrade(
						"Purchase an advanced hydroponics system",
						hydroponicsCost,
						'moderately decreases upkeep costs',
						"hydroponics"
					);

					upgradesDiv.append(upgrade);
				} else {
					const desc = document.createElement("div");

					desc.append(`${capFirstChar(V.farmyardName)} is outfitted with an advanced hydroponics system, reducing the amount of water your crops consume and thus moderately reducing upkeep costs.`);

					upgradesDiv.append(desc);

					if (!farmyardUpgrades.seeds) {
						const upgrade = createUpgrade(
							"Purchase genetically modified seeds",
							seedsCost,
							'moderately increases crop yield and slightly increases upkeep costs',
							"seeds"
						);

						upgradesDiv.append(upgrade);
					} else {
						const desc = document.createElement("div");

						desc.append(`${capFirstChar(V.farmyardName)} is using genetically modified seeds, significantly increasing the amount of crops it produces and moderately increasing upkeep costs.`);

						upgradesDiv.append(desc);

						if (!farmyardUpgrades.machinery) {
							const upgrade = createUpgrade(
								"Upgrade the machinery",
								machineryCost,
								'moderately increases crop yield and slightly increases upkeep costs',
								"machinery"
							);

							upgradesDiv.append(upgrade);
						} else {
							const desc = document.createElement("div");

							desc.append(`The machinery in ${V.farmyardName} has been upgraded, and is more efficient, significantly increasing crop yields and significantly decreasing upkeep costs.`);

							upgradesDiv.append(desc);
						}
					}
				}
			}
		}

		function createUpgrade(linkText, price, effect, type) {
			const desc = document.createElement("div");
			const link = App.UI.DOM.makeElement("div", null, "indent");
			const note = App.UI.DOM.makeElement("span", null, "note");
			const cost = App.UI.DOM.makeElement("span", null, "yellowgreen");

			cost.append(cashFormat(price));

			link.append(App.UI.DOM.passageLink(linkText, "Farmyard", () => {
				cashX(forceNeg(price), "farmyard");
				farmyardUpgrades[type] = 1;
			}));

			note.append(` Costs `, cost, ` and ${effect}.`);
			link.append(note);
			desc.append(link);

			return desc;
		}

		return upgradesDiv;
	}

	function animals() {
		const baseCost = Math.trunc(5000 * V.upgradeMultiplierArcology);
		const upgradedCost = Math.trunc(10000 * V.upgradeMultiplierArcology);

		let farmyardKennels = V.farmyardKennels;
		let farmyardStables = V.farmyardStables;
		let farmyardCages = V.farmyardCages;



		// MARK: Kennels

		const CL = V.canine.length;

		const dogs = CL === 1 ? `${V.canine[0]}s` : CL < 3 ?
			`several different breeds of dogs` :
			`all kinds of dogs`;
		const canines = CL === 1 ? V.canine[0].species === "dog" ?
			V.canine[0].breed : V.canine[0].speciesPlural : CL < 3 ?
			`several different ${V.canine.every(
				c => c.species === "dog") ?
				`breeds of dogs` : `species of canines`}` :
			`all kinds of canines`;

		const kennels = document.createElement("div");
		const kennelsUpgrade = App.UI.DOM.makeElement("div", null, "indent");
		const kennelsNote = App.UI.DOM.makeElement("span", null, "note");
		const kennelsCost = App.UI.DOM.makeElement("span", null, "yellowgreen");

		if (farmyardKennels === 0) {
			kennels.append(App.UI.DOM.passageLink("Add kennels", "Farmyard",
				() => {
					cashX(forceNeg(baseCost), "farmyard");
					V.farmyardKennels = 1;
				}));

			kennelsCost.append(cashFormat(baseCost));
			kennelsNote.append(` Costs `, kennelsCost, `, will incur upkeep costs, and unlocks domestic canines`);

			kennels.append(kennelsNote);
		} else if (farmyardKennels === 1) {
			kennels.append(App.UI.DOM.passageLink("Kennels", "Farmyard Animals"));
			kennels.append(` have been built in one corner of ${V.farmyardName}, and are currently ${CL < 1 ? `empty` : `occupied by ${dogs}`}.`);

			if (V.rep > 10000) {
				kennelsUpgrade.append(App.UI.DOM.passageLink("Upgrade kennels", "Farmyard",
					() => {
						cashX(forceNeg(upgradedCost), "farmyard");
						V.farmyardKennels = 2;
					}));

				kennelsCost.append(cashFormat(upgradedCost));
				kennelsNote.append(` Costs `, kennelsCost, `, will incur additional upkeep costs, and unlocks exotic canines`);

				kennelsUpgrade.append(kennelsNote);
				kennels.append(kennelsUpgrade);
			} else {
				kennelsNote.append(`You must be more reputable to be able to house exotic canines`);
				kennels.append(kennelsNote);
			}
		} else if (farmyardKennels === 2) {
			kennels.append(App.UI.DOM.passageLink("Large kennels", "Farmyard Animals"));
			kennels.append(` have been built in one corner of ${V.farmyardName}, and are currently ${CL < 1 ? `empty` : `occupied by ${canines}`}.`);
		}



		// MARK: Stables

		const HL = V.hooved.length;

		const hooved = HL === 1 ? `${V.hooved[0]}s` : HL < 3 ?
			`several different types of hooved animals` :
			`all kinds of hooved animals`;

		const stables = document.createElement("div");
		const stablesUpgrade = App.UI.DOM.makeElement("div", null, "indent");
		const stablesNote = App.UI.DOM.makeElement("span", null, "note");
		const stablesCost = App.UI.DOM.makeElement("span", null, "yellowgreen");

		if (farmyardStables === 0) {
			stables.append(App.UI.DOM.passageLink("Add stables", "Farmyard",
				() => {
					cashX(forceNeg(baseCost), "farmyard");
					V.farmyardStables = 1;
				}));

			stablesCost.append(cashFormat(baseCost));
			stablesNote.append(` Costs `, stablesCost, `, will incur upkeep costs, and unlocks domestic hooved animals`);

			stables.append(stablesNote);
		} else if (farmyardStables === 1) {
			stables.append(App.UI.DOM.passageLink("Stables", "Farmyard Animals"));
			stables.append(` have been built in one corner of ${V.farmyardName}, and are currently ${HL < 1 ? `empty` : `occupied by ${hooved}`}.`);

			if (V.rep > 10000) {
				stablesUpgrade.append(App.UI.DOM.passageLink("Upgrade stables", "Farmyard",
					() => {
						cashX(forceNeg(upgradedCost), "farmyard");
						V.farmyardStables = 2;
					}));

				stablesCost.append(cashFormat(upgradedCost));
				stablesNote.append(` Costs `, stablesCost, `, will incur additional upkeep costs, and unlocks exotic hooved animals`);

				stablesUpgrade.append(stablesNote);
				stables.append(stablesUpgrade);
			} else {
				stablesNote.append(`You must be more reputable to be able to house exotic hooved animals`);
				stables.append(stablesNote);
			}
		} else if (farmyardStables === 2) {
			stables.append(App.UI.DOM.passageLink("Large stables", "Farmyard Animals"));
			stables.append(` have been built in one corner of ${V.farmyardName}, and are currently ${HL < 1 ? `empty` : `occupied by ${hooved}`}.`);
		}



		// MARK: Cages

		const FL = V.feline.length;

		const cats = FL === 1 ? `${V.feline[0]}s` : FL < 3 ?
			`several different breeds of cats` :
			`all kinds of cats`;
		const felines = FL === 1 ? V.feline[0].species === "cat" ?
			V.feline[0].breed : V.feline[0].speciesPlural : FL < 3 ?
			`several different ${V.feline.every(
				c => c.species === "cat") ?
				`breeds of cats` : `species of felines`}` :
			`all kinds of felines`;

		const cages = document.createElement("div");
		const cagesUpgrade = App.UI.DOM.makeElement("div", null, "indent");
		const cagesNote = App.UI.DOM.makeElement("span", null, "note");
		const cagesCost = App.UI.DOM.makeElement("span", null, "yellowgreen");

		if (farmyardCages === 0) {
			cages.append(App.UI.DOM.passageLink("Add cages", "Farmyard",
				() => {
					cashX(forceNeg(baseCost), "farmyard");
					V.farmyardCages = 1;
				}));

			cagesCost.append(cashFormat(baseCost));
			cagesNote.append(` Costs `, cagesCost, `, will incur upkeep costs, and unlocks domestic felines`);

			cages.append(cagesNote);
		} else if (farmyardCages === 1) {
			cages.append(App.UI.DOM.passageLink("Cages", "Farmyard Animals"));
			cages.append(` have been built in one corner of ${V.farmyardName}, and are currently ${FL < 1 ? `empty` : `occupied by ${cats}`}.`);

			if (V.rep > 10000) {
				cagesUpgrade.append(App.UI.DOM.passageLink("Upgrade cages", "Farmyard",
					() => {
						cashX(forceNeg(upgradedCost), "farmyard");
						V.farmyardCages = 2;
					}));

				cagesCost.append(cashFormat(upgradedCost));
				cagesNote.append(` Costs `, cagesCost, `, will incur additional upkeep costs, and unlocks exotic felines`);

				cagesUpgrade.append(cagesNote);
				cages.append(cagesUpgrade);
			} else {
				cagesNote.append(`You must be more reputable to be able to house exotic felines`);
				cages.append(cagesNote);
			}
		} else if (farmyardCages === 2) {
			cages.append(App.UI.DOM.passageLink("Large cages", "Farmyard Animals"));
			cages.append(` have been built in one corner of ${V.farmyardName}, and are currently ${FL < 1 ? `empty` : `occupied by ${felines}`}.`);
		}



		// MARK: Remove Housing

		const removeHousing = document.createElement("div");
		const removeHousingNote = App.UI.DOM.makeElement("span", null, "note");
		const removeHousingCost = App.UI.DOM.makeElement("span", null, "yellowgreen");

		const removeHousingPrice = ((farmyardKennels + farmyardStables + farmyardCages) * 5000) * V.upgradeMultiplierArcology;

		if (farmyardKennels || farmyardStables || farmyardCages) {
			removeHousing.append(document.createElement("br"));

			removeHousing.append(App.UI.DOM.passageLink("Remove the animal housing", "Farmyard",
				() => {
					V.farmyardKennels = 0;
					V.farmyardStables = 0;
					V.farmyardCages = 0;

					V.farmyardShows = 0;
					V.farmyardBreeding = 0;
					V.farmyardRestraints = 0;

					clearAnimalsPurchased();
					cashX(forceNeg(removeHousingPrice), "farmyard");
				}));

			removeHousingCost.append(cashFormat(removeHousingPrice));
			removeHousingNote.append(` Will cost `, removeHousingCost);
			removeHousing.append(removeHousingNote);
		}

		animalsDiv.append(kennels, stables, cages, removeHousing);

		return animalsDiv;
	}

	function clearAnimalsPurchased() {
		V.canine = [];
		V.hooved = [];
		V.feline = [];

		V.active.canine = null;
		V.active.hooved = null;
		V.active.feline = null;
	}
};
