App.Facilities.Pit.animals = function() {
	const frag = new DocumentFragment();

	frag.append(animalSelect());

	return frag;



	// MARK: Main Function

	function animalSelect() {
		const animalSelectDiv = document.createElement("div");

		const animalLinks = [];
		const an = V.pit.animal.articleAn;

		animalSelectDiv.append(`Your slave will fight ${an} `, App.UI.DOM.makeElement("span", V.pit.animal.name, ["bold"]), `. `);

		if (V.active.canine) {
			animalLinks.push(canineSelect(animalSelectDiv));
		}

		if (V.active.hooved) {
			animalLinks.push(hoovedSelect(animalSelectDiv));
		}

		if (V.active.feline) {
			animalLinks.push(felineSelect(animalSelectDiv));
		}

		const links = App.UI.DOM.generateLinksStrip(animalLinks);

		animalSelectDiv.append(links);

		return animalSelectDiv;
	}



	// MARK: Canine

	function canineSelect(div) {
		let animalEligible = true;

		switch (V.active.canine.name) {
			case "beagle":
			case "French bulldog":
			case "poodle":
			case "Yorkshire terrier":
				animalEligible = false;
				break;
		}

		if (V.pit.animal.name === V.active.canine.name) {
			return App.UI.DOM.disabledLink(capFirstChar(V.active.canine.name), [`Already selected.`]);
		}

		if (animalEligible) {
			return App.UI.DOM.link(capFirstChar(V.active.canine.name), () => {
				V.pit.animal = V.active.canine;

				App.UI.DOM.replace(div, animalSelect);
			});
		} else {
			return App.UI.DOM.disabledLink(capFirstChar(V.active.canine.name), [`${V.active.canine.name}s are too small for a proper fight.`]);
		}
	}



	// MARK: Hooved

	function hoovedSelect(div) {
		if (V.pit.animal.name === V.active.hooved.name) {
			return App.UI.DOM.disabledLink(capFirstChar(V.active.hooved.name), [`Already selected.`]);
		}

		return App.UI.DOM.link(capFirstChar(V.active.hooved.name), () => {
			V.pit.animal = V.active.hooved;

			App.UI.DOM.replace(div, animalSelect);
		});
	}



	// MARK: Felines

	function felineSelect(div) {
		const cat = "cat";

		if (V.pit.animal.name === V.active.feline.name) {
			return App.UI.DOM.disabledLink(capFirstChar(V.active.feline.name), [`Already selected.`]);
		}

		if (V.active.feline.species === cat) {
			return App.UI.DOM.disabledLink(capFirstChar(V.active.feline.name), [`${V.active.feline.name}s are too small for a proper fight.`]);
		} else {
			return App.UI.DOM.link(capFirstChar(V.active.feline.name), () => {
				V.pit.animal = V.active.feline;

				App.UI.DOM.replace(div, animalSelect);
			});
		}
	}
};
