App.UI.updateSidebarTooltips = (function() {
	// The performance impact is around O(tooltips * nodes), with large passages (main, slave assignment report) adding
	// tooltips could potentially take a significant amount of time when there are many potential tooltips.
	const tooltips = {
		exampleTooltip: "I am a helpful tooltip. We are very rare because we are still in development.",

		devotion: "Devotion is a measure of a slave's love for you.",
		trust: "Trust is a measure of a slave's expectations of you and confidence to perform well.",
		defiant: "Defiant slaves will actively work against you.",

		flaw: "Flaws impend your slaves performance. Try removing or converting them into quirks.",
		intelligent: "More intelligent slaves tend to perform better.",
		stupid: "More intelligent slaves tend to perform better.",
		health: "The healthier your slaves, the better they perform.",
		libido: "Sex drive has various effects, generally higher is good.",
		positive: "This is good.",
		// noteworthy: "This is important.",
		warning: "This is very bad. Try removing the cause for this.",

		error: "Something just broke. Please report this.",

		cash: "Money. Always useful.",
		reputation: "Your reputation as a slaveowner. The more, the better.",
		/*
		red: "This is red, it's bad, if indicating a stat change it could be about money, reputation, mindbreak or flaw gain.",
		skill: "t",
		fetish: "t",
		relationship: "t",
		change: "t",
		virginity: "t",
		pregnant: "t",
		education: "t",
		*/
	};

	/**
	 * @param {Document|HTMLElement} container
	 */
	function addTooltips(container) {
		if (V.tooltipsEnabled === 0) {
			return;
		}
		for (const tooltipsKey in tooltips) {
			const elements = container.getElementsByClassName(tooltipsKey);
			for (const element of elements) {
				element.title += `${tooltips[tooltipsKey]}\n`;
			}
		}
	}

	function updateSidebar() {
		addTooltips(document.getElementById("story-caption"));
	}

	// passage
	$(document).on(":passagerender", e => addTooltips(e.content));
	// story caption
	$(document).on(":passageend", updateSidebar);
	// dialog
	$(document).on(":dialogopening", e => addTooltips(e.target));

	return updateSidebar;
})();
