App.UI.SlaveInteract.mainPage = function(slave) {
	const el = new DocumentFragment();
	App.UI.tabBar.handlePreSelectedTab(V.tabChoice.SlaveInteract);

	if (!assignmentVisible(slave)) {
		switch (slave.assignment) {
			case "work in the brothel":
			case "be the Madam":
				V.nextLink = "Brothel";
				break;
			case "be confined in the arcade":
				V.nextLink = "Arcade";
				break;
			case "serve in the club":
			case "be the DJ":
				V.nextLink = "Club";
				break;
			case "work in the dairy":
			case "be the Milkmaid":
				V.nextLink = "Dairy";
				break;
			case "work as a farmhand":
			case "be the Farmer":
				V.nextLink = "Farmyard";
				break;
			case "rest in the spa":
			case "be the Attendant":
				V.nextLink = "Spa";
				break;
			case "work as a nanny":
			case "be the Matron":
				V.nextLink = "Nursery";
				break;
			case "learn in the schoolroom":
			case "be the Schoolteacher":
				V.nextLink = "Schoolroom";
				break;
			case "work as a servant":
			case "be the Stewardess":
				V.nextLink = "Servants' Quarters";
				break;
			case "serve in the master suite":
			case "be your Concubine":
				V.nextLink = "Master Suite";
				break;
			case "be confined in the cellblock":
			case "be the Wardeness":
				V.nextLink = "Cellblock";
				break;
			case "get treatment in the clinic":
			case "be the Nurse":
				V.nextLink = "Clinic";
				break;
			case "live with your Head Girl":
				V.nextLink = "Head Girl Suite";
				break;
			case "be your agent":
			case "live with your agent":
				V.nextLink = "Neighbor Interact";
		}
	}

	V.encyclopedia = either("Costs Summary", "Disease in the Free Cities", "Drugs and Their Effects", "From Rebellious to Devoted", "Gender", "Independent Slaves", "Modern Anal", "Nymphomania", "Slave Couture");
	if (slave.dick > 0) {
		V.encyclopedia = "Gender";
	}
	App.Utils.scheduleSidebarRefresh();

	/**
	 * @typedef {Object} siCategory
	 * @property {string} title
	 * @property {string} id
	 * @property {DocumentFragment|HTMLElement} node
	 * @property {Function} [onClick]
	 */

	 /** @type {Array<siCategory>} */
	const buttons = [
		{
			title: "Description",
			id: "description",
			get node() { return App.UI.SlaveInteract.description(slave); }
		},
		{
			title: "Modify",
			id: "modify",
			get node() { return App.UI.SlaveInteract.modify(slave); }
		},
		{
			title: "Work",
			id: "work",
			get node() { return App.UI.SlaveInteract.work(slave); }
		},
		{
			title: "Appearance",
			id: "appearance",
			get node() { return App.UI.SlaveInteract.wardrobe(slave); }
		},
		{
			title: "Physical Regimen",
			id: "physical-regimen",
			get node() { return App.UI.SlaveInteract.physicalRegimen(slave); }
		},
		{
			title: "Rules",
			id: "rules",
			get node() { return App.UI.SlaveInteract.rules(slave); }
		},
		{
			title: "Financial",
			id: "financial",
			get node() { return App.UI.SlaveInteract.financial(slave); }
		},
		{
			title: "Customize",
			id: "customize",
			get node() { return App.UI.SlaveInteract.custom(slave); }
		},
		{
			title: "Family",
			id: "family-tab",
			onClick: () => {
				renderFamilyTree(V.slaves, slave.ID);
			},
			get node() { return App.UI.SlaveInteract.family(); }
		}
	];

	el.append(App.UI.SlaveInteract.navigation(slave));

	if (V.slaveInteractLongForm) {
		el.append(displayWithoutTabs());
	} else {
		el.append(displayWithTabs());
	}

	return el;

	function displayWithTabs() {
		const el = new DocumentFragment();

		const tabBar = document.createElement("div");
		tabBar.classList.add("tab-bar");
		const tabContents = new DocumentFragment();

		for (const item of buttons) {
			tabBar.append(makeTabButton(item));
			tabContents.append(makeTabContents(item));
		}

		el.append(tabBar);

		App.Events.drawEventArt(el, slave);

		el.append(tabContents);

		return el;

		/**
		 * @param {siCategory} item
		 * @returns {HTMLElement}
		 */
		function makeTabButton(item) {
			const btn = document.createElement("button");
			btn.className = "tab-links";
			btn.id = `tab ${item.id}`;
			btn.innerHTML = item.title;
			btn.onclick = (event) => {
				App.UI.tabBar.openTab(event, item.id);
				jQuery(`#content-${item.id}`).empty().append(item.node);
				if (item.hasOwnProperty("onClick")){
					item.onClick();
				}
			};

			return btn;
		}
	}

	/**
	 * @returns {DocumentFragment}
	 */
	function displayWithoutTabs() {
		const el = new DocumentFragment();
		App.Events.drawEventArt(el, slave);
		for (const item of buttons) {
			App.UI.DOM.appendNewElement("h2", el, item.title);
			el.append(makeContentSpan(item));
			if (item.hasOwnProperty("onClick")) {
				item.onClick();
			}
		}
		return el;
	}

	/**
	 * @param {siCategory} item
	 * @returns {HTMLElement}
	 */
	function makeTabContents(item) {
		const wrapperEl = document.createElement("div");
		wrapperEl.id = item.id;
		wrapperEl.classList.add("tab-content");

		const classEl = document.createElement("div");
		classEl.classList.add("content");

		classEl.append(makeContentSpan(item));
		wrapperEl.append(classEl);

		return wrapperEl;
	}

	/**
	 * @param {siCategory} item
	 * @returns {HTMLElement}
	 */
	function makeContentSpan(item) {
		const uniqueContent = document.createElement("span");
		uniqueContent.id = `content-${item.id}`;

		uniqueContent.append(item.node);
		return uniqueContent;
	}
};
