/**
 * @param {App.Entity.SlaveState} slave
 * @param {object} params
 * @param {FC.Zeroable<FC.SlaveMarketName>} [params.market]
 * @param {boolean} [params.eventDescription]
 * @returns {string}
 */
App.Desc.sceneIntro = function(slave, {market, eventDescription} = {}) {
	const r = [];
	const {
		he, him, his, He, His, himself, wife
	} = getPronouns(slave);

	if (eventDescription) {
		r.push(`${He} is currently involved in an event, but is assigned to ${slave.assignment}.`);
		if (slave.assignment === "be a subordinate slave") {
			let lsd = getSlave(slave.subTarget);
			if (lsd) {
				r.push(`${He} has been ordered to serve <span class="slave name simple">${SlaveFullName(lsd)}</span> specifically.`);
			}
		}
	} else if (V.ui !== "start" && !market) {
		r.push(inspectionIntro());
		if (slave.sentence > 0) {
			r.push(sentence());
		}
		if (slave.fuckdoll === 0) {
			if (slave.voice !== 0) {
				r.push(voice());
			}
		}
		r.push(relationship());
		if (slave.fuckdoll === 0) {
			r.push(sleepLoc());
		}
	}
	return r.join(" ");

	function inspectionIntro() {
		const r = [];
		if (slave.fuckdoll > 0) {
			r.push(`You order another slave to bring ${him} before your desk so you can inspect ${him}.`);
		} else if ((slave.assignment === "work in the dairy") && (V.dairyRestraintsSetting > 1)) {
			r.push(`You go down to ${V.dairyName} to inspect ${his} heaving body.`);
		} else if (slave.assignment === "be your agent") {
			const arc = V.arcologies.find(a => a.leaderID === slave.ID);
			r.push(`You place a call to ${arc ? arc.name : `${his} current location`}, and ${he} instantly appears on camera.`);
		} else {
			r.push(`${He} comes to you for an inspection`);
			switch (slave.assignment) {
				case "whore":
					r.push(`between customers.`);
					break;
				case "serve the public":
					r.push(`from where ${he} was offering ${him}self publicly.`);
					break;
				case "work a glory hole":
					r.push(`straight from confinement in a glory hole.`);
					break;
				case "get milked":
					r.push(`between milkings.`);
					break;
				case "work as a farmhand":
					r.push(`from where ${he} was taking care of crops and animals.`);
					break;
				case "rest":
					r.push(`from where ${he} was resting.`);
					break;
				case "work as a nanny":
					r.push(`from where ${he} was`);
					if (V.nurseryChildren === 1) {
						r.push(`taking care of a child.`);
					} else if (V.nurseryChildren > 0) {
						r.push(`taking care of children.`);
					} else {
						r.push(`keeping ${V.nurseryName} clean.`);
					}
					break;
				case "please you":
					r.push(`from where ${he} was offering ${himself} to you.`);
					break;
				case "be a subordinate slave":
					if (slave.subTarget === -1) {
						r.push(`from where ${he} was resting after ${his} latest baby-making session.`);
					} else {
						r.push(`straight from orally servicing another slave.`);
					}
					break;
				case "be a servant":
					r.push(`straight from bathing another slave.`);
					break;
				case "train slaves":
					r.push(`between slave training contracts.`);
					break;
				case "stay confined":
					r.push(`straight from ${his} confinement.`);
					break;
				case "guard you":
					r.push(`armed and alert.`);
					break;
				case "recruit girls":
					if (V.recruiterTarget !== "other arcologies") {
						r.push(`after ${he} finishes cybering with a prospective recruit.`);
					} else {
						if (V.arcologies[0].influenceTarget === -1) {
							r.push(`right away, since you haven't decided on an arcology to target for cultural influence, leaving ${him} with nothing to do.`);
						} else {
							const arc = V.arcologies.find(a => a.direction === V.arcologies[0].influenceTarget);
							r.push(`from where ${he} was resting after ${his} latest sexually exhausting visit to ${arc ? arc.name : "a nearby arcology"}.`);
						}
					}
					break;
				case "be your Head Girl":
					r.push(`with updates on your other slaves ready for your review.`);
					break;
				default:
					r.push(`as quickly as ${he} can.`);
			}
		}
		return r.join(" ");
	}

	function sentence() {
		const r = [];

		if (slave.assignment === "work a glory hole") {
			r.push(`${His} sentence lasts another`);
			if (slave.sentence > 1) {
				r.push(`${slave.sentence} weeks.`);
			} else {
				r.push(`week.`);
			}
		} else {
			r.push(`${His} work assignment lasts another`);
			if (slave.sentence > 1) {
				r.push(`${slave.sentence} weeks.`);
			} else {
				r.push(`week.`);
			}
		}

		return r.join(" ");
	}

	function voice() {
		const r = [];

		if (slave.rules.speech === "restrictive") {
			r.push(`${He} is not allowed to speak unless spoken to, but when allowed, ${he} speaks in a`);
		} else {
			r.push(`${He} is allowed to ask questions, and when ${he} speaks, ${he} does so in a`);
		}
		if (slave.voice === 1) {
			if (slave.voiceImplant < 0) {
				r.push(`ridiculously deep, gravelly voice.`);
			} else {
				r.push(`deep, unfeminine voice.`);
			}
		} else if (slave.voice === 2) {
			if (slave.voiceImplant !== 0) {
				r.push(`slightly artificial feminine voice.`);
			} else {
				r.push(`pretty, feminine voice.`);
			}
		} else if (slave.voice === 3) {
			if (slave.voiceImplant > 0) {
				r.push(`ridiculously high, bubblegum voice.`);
			} else {
				r.push(`high, girly voice.`);
			}
		}

		if (canTalk(slave, false)) {
			r.push(App.Desc.accent(slave));
		}

		return r.join(" ");
	}

	function relationship() {
		const r = [];
		if (slave.relationship === -3) {
			if (slave.fetish === "mindbroken") {
				r.push(`${He} is <span class="relationship">married to you,</span> not that it matters to ${his} broken mind; to ${him}, ${he} is a slave, nothing more.`);
			} else if (slave.devotion + slave.trust >= 175) {
				r.push(`${He} is <span class="relationship">happily married to you,</span> though of course ${he} is still your slave; albeit a loving, devoted one.`);
			} else if (slave.devotion < -20 && slave.trust > 20) {
				r.push(`${He} is <span class="relationship">reluctantly married to you,</span> though of course ${he} is still your slave.`);
			} else if (slave.devotion < -20) {
				r.push(`${He} is <span class="relationship">forcibly married to you,</span> though of course ${he} is still your slave.`);
			} else {
				r.push(`${He} is <span class="relationship">married to you,</span> though of course ${he} is still your slave.`);
			}
		} else if (slave.relationship === -1) {
			r.push(`${He} is an <span class="relationship">emotional slut,</span> happy to remain officially single and free to treat everyone equally.`);
		} else if (slave.relationship === -2) {
			r.push(`${He} is <span class="relationship">emotionally bound to you;</span> ${his} feelings for you are comparable to those in a healthy, loving relationship.`);
		} else if (slave.relationship !== 0) {
			let lsd = getSlave(slave.relationshipTarget);
			if (lsd) {
				r.push(`${He} is`);
				// TODO: update this with the new relationship rules
				if (slave.relationship <= 1) {
					r.push(`<span style="font-weight:bold" class="relationship">friends with ${SlaveFullName(lsd)};</span> the rules`);
					if (slave.rules.relationship !== "restrictive") {
						r.push(`encourage`);
					} else {
						r.push(`discourage`);
					}
					r.push(`their relationship.`);
				} else if (slave.relationship <= 2) {
					r.push(`<span style="font-weight:bold" class="relationship">best friends with ${SlaveFullName(lsd)};</span> the rules`);
					if (slave.rules.relationship !== "restrictive") {
						r.push(`encourage`);
					} else {
						r.push(`discourage`);
					}
					r.push(`their close relationship.`);
				} else if (slave.relationship <= 3) {
					r.push(`<span style="font-weight:bold" class="relationship">${SlaveFullName(lsd)}'s friend with benefits;</span> the rules`);
					if (slave.rules.relationship === "permissive") {
						r.push(`encourage`);
					} else {
						r.push(`discourage`);
					}
					r.push(`their sexual relationship.`);
				} else if (slave.relationship <= 4) {
					r.push(`<span style="font-weight:bold" class="relationship">${SlaveFullName(lsd)}'s lover;</span> the rules`);
					if (slave.rules.relationship === "permissive") {
						r.push(`encourage`);
					} else {
						r.push(`discourage`);
					}
					r.push(`their passionate relationship.`);
				} else if (slave.relationship > 4) {
					r.push(`<span style="font-weight:bold" class="relationship">${SlaveFullName(lsd)}'s slave ${wife};</span> the rules`);
					if (slave.rules.relationship === "permissive") {
						r.push(`encourage`);
					} else {
						r.push(`discourage`);
					}
					r.push(`marital bliss.`);
				}
			}
		} else if (slave.fuckdoll === 0) {
			if (slave.rules.relationship === "restrictive") {
				r.push(`The rules forbid ${him} from associating freely with other slaves.`);
			} else if (slave.career === "a Futanari Sister") {
				r.push(`The rules encourage ${him} to form friendships with other slaves, but ${he} seems disinclined to do so. ${He}'s both friendly with them and eagerly sexual with them when allowed, but ${he} seems to be waiting for someone, deep down.`);
			} else if (slave.rules.relationship === "just friends") {
				r.push(`The rules encourage ${him} to form friendships with other slaves.`);
			} else {
				r.push(`The rules encourage ${him} to form relationships with other slaves.`);
			}
		}

		return r.join(" ");
	}

	function sleepLoc() {
		const r = [];

		if (slave.ID === V.HeadGirlID && V.HGSuite === 1) {
			r.push(`${He} lives in ${his} own suite within your penthouse,`);
		} else if ((slave.ID === V.BodyguardID) && (V.dojo > 1)) {
			r.push(`${He} lives in ${his} own room within the armory,`);
		} else if ((slave.assignment === "work in the dairy") && (V.dairyRestraintsSetting > 1)) {
			r.push(`${He} sleeps attached to a milking machine,`);
		} else if (slave.rules.living === "spare") {
			r.push(`${He} sleeps on a bedroll,`);
		} else if (slave.rules.living === "normal") {
			r.push(`${He} sleeps on a cot,`);
		} else if (slave.relationship >= 4) {
			r.push(`${He} has ${his} own room, which ${he} shares with ${his}`);
			if (slave.relationship === 5) {
				r.push(wife);
			} else {
				r.push(`${getPronouns(slave).girl}friend`);
			}
			r.push(`whenever they can manage it,`);
		} else {
			r.push(`${He} sleeps in ${his} own little room,`);
		}
		r.push(App.Desc.releaseDesc(slave));

		return r.join(" ");
	}
};
