/**
 * @param {App.Entity.SlaveState} slave
 */
App.UI.SlaveInteract.killSlave = function(slave) {
	// MARK: Declarations

	const frag = new DocumentFragment();
	const {He, His, he, him, his, daughter, himself} = getPronouns(slave);

	const FS = {
		FSRomanRevivalist: 'gladius',
		FSNeoImperialist: 'estoc',
		FSAztecRevivalist: 'Tecpatl',
		FSEgyptianRevivalist: 'kopesh',
		FSEdoRevivalist: 'katana',
		FSArabianRevivalist: 'scimitar',
		FSChineseRevivalist: 'jian',
	};

	let weapon = "handgun";
	let qualifiedFS = false;

	for (const fs in FS) {
		if (V.arcologies[0][fs] !== "unset") {
			qualifiedFS = true;
			weapon = FS[fs];
		}
	}

	frag.appendChild(intro());

	if (V.pit && V.pit.slaveFightingBodyguard) {
		frag.appendChild(plannedFight());
	} else {
		frag.appendChild(links());
	}

	return frag;



	// MARK: Text Functions

	function intro() {
		const introDiv = document.createElement("div");

		introDiv.append(`You ${canWalk(slave) ?
			`call ${slave.slaveName}` :
			`have ${slave.slaveName} brought`} into your office. `);

		if (slave.fuckdoll) {
			introDiv.append(`It's hard to tell the expression on the Fuckdoll's face, but your guess is it's `);

			if (slave.fetish !== "mindbroken") {
				introDiv.append(`one of `);

				if (slave.devotion > 50) {
					introDiv.append(`adoration. `);
				} else if (slave.devotion > 20) {
					introDiv.append(`calm. `);
				} else if (slave.devotion > -20) {
					introDiv.append(`apprehension. `);
				} else {
					introDiv.append(`hatred. `);
				}
			} else {
				introDiv.append(`blank. `);
			}
		} else {
			introDiv.append(`${He} looks at you `);

			if (slave.devotion > 50) {
				introDiv.append(`with adoration`);
			} else if (slave.devotion > 20) {
				introDiv.append(`calmly`);
			} else if (slave.devotion > -20) {
				introDiv.append(`with apprehension`);
			} else {
				introDiv.append(`with hatred`);
			}

			introDiv.append(` and waits for you to continue. `);
		}

		introDiv.append(`You tell ${him} that you've gotten tired of having ${him} around and that you decided it is time to get rid of ${him}. `);

		if (slave.fuckdoll) {
			introDiv.append(`${He} simply nods, not being able to see `);
		} else {
			if (slave.fetish !== "mindbroken") {
				introDiv.append(`${His} expression changes to one of `);

				if (slave.devotion > 50) {
					introDiv.append(`pure sorrow`);
				} else if (slave.devotion > 20) {
					introDiv.append(`sadness`);
				} else {
					introDiv.append(`relief`);
				}

				introDiv.append(` until `);
			} else {
				introDiv.append(`${He} just nods dumbly and continues to watch you with a vacant expression, even as `);
			}
		}

		introDiv.append(`you ${canHear(slave) ? `quietly ` : ``}reach behind your desk and pull out your trusty ${weapon}`);

		if (!slave.fuckdoll && canSee(slave)) {
			if (slave.fetish !== "mindbroken") {
				introDiv.append(`, at which point abject fear fills ${his} face. ${He} immediately ${hasBothLegs(slave) ? `drops to ${his} knees and ` : ``}begins openly begging for you to show mercy.`);
			} else {
				introDiv.append(`, to which ${he} still doesn't respond. `);
			}
		} else {
			introDiv.append(`. `);
		}

		return introDiv;
	}

	function links() {
		const linksDiv = App.UI.DOM.makeElement("div", '', "kill-slave-options");

		const links = [];
		const disableReasons = [];

		const combatLinkText = `Let ${him} win ${his} life in combat`;

		linksDiv.id = "kill-scene";

		links.push(
			App.UI.DOM.link(`Kill ${him}`, () => {
				App.UI.DOM.replace(linksDiv, kill);
			}),
			App.UI.DOM.link(`Have mercy on ${him}`, () => {
				App.UI.DOM.replace(linksDiv, mercy);
			}),
		);

		if (V.pit.slaveFightingBodyguard) {
			disableReasons.push(`You already have a slave fighting your bodyguard this week.`);
		}

		if (slave.fuckdoll) {
			disableReasons.push(`Fuckdolls cannot properly fight.`);
		}

		if (slave.fetish === "mindbroken") {
			disableReasons.push(`Mindbroken slaves cannot properly fight.`);
		}

		if (!S.Bodyguard) {
			disableReasons.push(`You must have a bodyguard for ${slave.slaveName} to fight.`);
		}

		if (!V.pit) {
			disableReasons.push(`You must first build a pit for combat.`);
		} else {
			if (!V.pit.lethal) {
				disableReasons.push(`You must allow lethal fights in ${V.pit.name}.`);
			}
		}


		if (disableReasons) {
			links.push(App.UI.DOM.disabledLink(combatLinkText, disableReasons));
		} else {
			links.push(App.UI.DOM.link(combatLinkText, () => {
				App.UI.DOM.replace(linksDiv, combat);
			}));
		}

		linksDiv.appendChild(App.UI.DOM.generateLinksStrip(links));

		return linksDiv;
	}

	function kill() {
		const killDiv = document.createElement("div");

		if (!slave.fuckdoll && slave.fetish !== "mindbroken") {
			killDiv.append(`You simply smile at ${him} and tell ${him} not to worry `);
		} else {
			killDiv.append(`You say nothing `);
		}

		killDiv.append(`as you continue ${qualifiedFS ?
			`sharpening your ${weapon}.` :
			`threading on a suppressor.`} ${slave.slaveName} ${!slave.fuckdoll && slave.fetish !== "mindbroken" ?
			`gives an audible sigh of relief and begins to thank you profusely, though ${his} thanks are cut short as the sound of` :
			`continues to stand there ${slave.fetish === "mindbroken" ? `dumbly` : ``} until the sound of`} ${qualifiedFS ?
			`a sharp edge slicing through flesh` :
			`a suppressed gunshot`} rings through the room. You have another servant clean up the mess as you continue with what you were previously doing.`);

		killDiv.appendChild(relations());

		removeSlave(slave);

		return killDiv;
	}

	function mercy() {
		const mercyDiv = document.createElement("div");

		if (!slave.fuckdoll && slave.fetish !== "mindbroken") {
			mercyDiv.append(`You make a show of considering sparing ${his} life, then, with a heavy sigh, unbuckle your pants and sit down at your desk. You beckon to ${him}, and ${he} just about trips over ${himself} as ${he} hastily makes ${his} way over to you. ${His} blowjob isn't the best you've ever had, ${him} `, App.UI.DOM.makeElement("span", `sobbing`, ["trust", "dec"]), ` as much as ${he} is; but ${his} enthusiasm more than makes up for it. After you finish deep in ${his} throat, ${he} sits back and wipes away ${his} tears, sniffling and `, App.UI.DOM.makeElement("span", `thanking you again`, ["devotion", "inc"]), ` for giving ${him} another chance.`);
		} else {
			mercyDiv.append(`You change your mind, and with a wave of your hand, send ${slave.slaveName} back to ${his} duties. Maybe some other time.`);
		}

		slave.devotion = slave.devotion < 30 ? 30 : slave.devotion += 30;
		slave.trust -= 100;

		return mercyDiv;
	}

	function combat() {
		const combatDiv = document.createElement("div");

		combatDiv.append(`You tell ${him} you'll let your bodyguard decide ${his} fate — if ${he} wants to live, ${he}'ll have to beat ${S.Bodyguard.slaveName} in hand-to-hand combat in ${V.pit.name}.`);

		if (slave.skill.combat) {
			combatDiv.append(`${He} nods ${his} head and straightens up, as though mentally preparing ${himself} for the fight for ${his} life.`);
		} else {
			combatDiv.append(`The fear on ${his} face is palpable, though ${he} nods slowly and agrees, not seeing another choice.`);
		}

		V.pit.slaveFightingBodyguard = slave.ID;
		V.pit.lethal = true;
		V.pit.animal = null;

		return combatDiv;
	}

	function relations() {
		// TODO: potentially expand to allow for checking for more than one relation (i.e. sister/mother/lover, etc)
		const relationsDiv = App.UI.DOM.makeElement("div", '', "kill-slave-relations");

		const halfSisters = [];
		const sisters = [];
		const twins = [];
		const daughters = [];

		const isWife = slave.relationship === -3;

		let mother = null;
		let father = null;
		let relationshipTarget = null;
		let rival = null;

		for (const target of V.slaves) {
			if (target.devotion > 50 && isWife) {
				target.trust -= 25;
			}

			if (slave.mother === target.ID) {
				mother = target.ID;
				continue;
			}

			if (slave.father === target.ID) {
				father = target.ID;
				continue;
			}

			if (target.mother === slave.ID || target.father === slave.ID) {
				daughters.push(target.ID);
				continue;
			}

			if (areSisters(slave, target)) {
				switch (areSisters(slave, target)) {
					case 1:
						twins.push(target.ID);
						continue;
					case 2:
						sisters.push(target.ID);
						continue;
					case 3:
						halfSisters.push(target.ID);
						continue;
					default:
						throw new Error(`Unexpected value '${areSisters(slave, target)}' found in relations()`);
				}
			}

			if (slave.relationship > 0 && slave.relationshipTarget === target.ID) {
				relationshipTarget = target.ID;
				continue;
			}

			if (slave.rivalry && slave.rivalryTarget === target.ID) {
				rival = target.ID;
				continue;
			}
		}

		if (mother) {
			const subDiv = document.createElement("div");

			mother = getSlave(mother);

			subDiv.append(`${His} mother ${mother.slaveName} is `, App.UI.DOM.makeElement("span", 'grief-stricken', ["devotion", "dec"]), ` that you would take ${his} ${daughter} from ${getPronouns(mother).him}.`);
			relationsDiv.appendChild(subDiv);

			mother.devotion -= 30;
		}

		if (father) {
			const subDiv = document.createElement("div");

			father = getSlave(father);

			subDiv.append(`${His} father ${father.slaveName} is `, App.UI.DOM.makeElement("span", 'grief-stricken', ["devotion", "dec"]), ` that you would take ${his} ${daughter} from ${getPronouns(father).him}.`);
			relationsDiv.appendChild(subDiv);

			father.devotion -= 30;
		}

		if (daughters.length) {
			if (daughters.length === 1) {
				const subDiv = document.createElement("div");

				const daughter = getSlave(daughters[0]);
				const mother = getPronouns(slave).mother;
				const {him: him2, daughter: daughter2} = getPronouns(daughter);

				subDiv.append(`${His} ${daughter2} ${daughter.slaveName} is `, App.UI.DOM.makeElement("span", 'horrified', ["devotion", "dec"]), ` that you would take ${his} ${mother} from ${him2}.`);
				relationsDiv.appendChild(subDiv);

				daughter.devotion -= 25;
			} else {
				const subDiv = document.createElement("div");
				const daughtersSpan = document.createElement("span");

				const mother = getPronouns(slave).mother;

				if (daughters.length > 2) {
					let lastDaughter = daughters.pop();

					for (const daughter of daughters) {
						daughtersSpan.append(`${getSlave(daughter).slaveName}, `);
					}

					daughtersSpan.append(` and ${getSlave(lastDaughter).slaveName}`);
				} else {
					daughtersSpan.append(`${getSlave(daughters[0]).slaveName} and ${getSlave(daughters[1]).slaveName}`);
				}

				daughters.forEach(i => daughters[i].devotion -= 25);

				subDiv.append(`${His} children, `, daughtersSpan, `, are `, App.UI.DOM.makeElement("span", 'horrified', ["devotion", "dec"]), ` that you would take their ${mother} from them.`);
				relationsDiv.appendChild(subDiv);
			}
		}

		if (twins.length) {
			if (twins.length === 1) {
				const subDiv = document.createElement("div");

				const twin = getSlave(twins[0]);
				const sister = getPronouns(slave).sister;
				const {him: him2} = getPronouns(twin);

				subDiv.append(`${His} twin ${twin.slaveName} is `, App.UI.DOM.makeElement("span", 'devastated', ["devotion", "dec"]), ` that you would take ${his} ${sister} from ${him2}.`);
				relationsDiv.appendChild(subDiv);

				twin.devotion -= 30;
			} else {
				const subDiv = document.createElement("div");
				const twinsSpan = document.createElement("span");

				const sister = getPronouns(slave).sister;

				if (twins.length > 2) {
					let lastTwin = twins.pop();

					for (const twin of twins) {
						twinsSpan.append(`${getSlave(twin).slaveName}, `);

						getSlave(twin).devotion -= 30;
					}

					twinsSpan.append(` and ${getSlave(lastTwin).slaveName}`);
				} else {
					twinsSpan.append(`${getSlave(twins[0]).slaveName} and ${getSlave(twins[1]).slaveName}`);
				}

				twins.forEach(i => twins[i].devotion -= 30);

				subDiv.append(`${His} twins, `, twinsSpan, `, are `, App.UI.DOM.makeElement("span", 'devastated', ["devotion", "dec"]), ` that you would take their ${sister} from them.`);
				relationsDiv.appendChild(subDiv);
			}
		}

		if (sisters.length) {
			if (sisters.length === 1) {
				const subDiv = document.createElement("div");

				const firstSister = getSlave(sisters[0]);
				const sister = getPronouns(slave).sister;
				const {him: him2} = getPronouns(firstSister);

				subDiv.append(`${His} sister ${firstSister.slaveName} is `, App.UI.DOM.makeElement("span", 'grief-stricken', ["devotion", "dec"]), ` that you would take ${his} ${sister} from ${him2}.`);
				relationsDiv.appendChild(subDiv);

				firstSister.devotion -= 25;
			} else {
				const subDiv = document.createElement("div");
				const sistersSpan = document.createElement("span");

				const sister = getPronouns(slave).sister;

				if (sisters.length > 2) {
					let lastSister = sisters.pop();

					for (const sister of sisters) {
						sistersSpan.append(`${getSlave(sister).slaveName}, `);
					}

					sistersSpan.append(` and ${getSlave(lastSister).slaveName}`);
				} else {
					sistersSpan.append(`${getSlave(sisters[0]).slaveName} and ${getSlave(sisters[1]).slaveName}`);
				}

				sisters.forEach(i => sisters[i].devotion -= 25);

				subDiv.append(`${His} sister, `, sistersSpan, `, are `, App.UI.DOM.makeElement("span", 'grief-stricken', ["devotion", "dec"]), ` that you would take their ${sister} from them.`);
				relationsDiv.appendChild(subDiv);
			}
		}

		if (halfSisters.length) {
			if (halfSisters.length === 1) {
				const subDiv = document.createElement("div");

				const halfSister = getSlave(halfSisters[0]);
				const sister = getPronouns(slave).sister;
				const {him: him2} = getPronouns(halfSister);

				subDiv.append(`${His} half-sister ${halfSister.slaveName} is `, App.UI.DOM.makeElement("span", 'saddened', ["devotion", "dec"]), ` that you would take ${his} ${sister} from ${him2}.`);
				relationsDiv.appendChild(subDiv);

				halfSister.devotion -= 20;
			} else {
				const subDiv = document.createElement("div");
				const halfSistersSpan = document.createElement("span");

				const sister = getPronouns(slave).sister;

				if (halfSisters.length > 2) {
					let lastHalfSister = halfSisters.pop();

					for (const sister of halfSisters) {
						halfSistersSpan.append(`${getSlave(sister).slaveName}, `);
					}

					halfSistersSpan.append(` and ${getSlave(lastHalfSister).slaveName}`);
				} else {
					halfSistersSpan.append(`${getSlave(halfSisters[0]).slaveName} and ${getSlave(halfSisters[1]).slaveName}`);
				}

				halfSisters.forEach(i => halfSisters[i].devotion -= 20);

				subDiv.append(`${His} half-sisters, `, halfSistersSpan, `, are `, App.UI.DOM.makeElement("span", 'saddened', ["devotion", "dec"]), ` that you would take their ${sister} from them.`);
				relationsDiv.appendChild(subDiv);
			}
		}

		if (relationshipTarget) {
			if (getSlave(relationshipTarget).fetish !== "mindbroken") {
				const subDiv = document.createElement("div");

				const target = getSlave(relationshipTarget);

				subDiv.append(`${target.slaveName} is `, App.UI.DOM.makeElement("span", 'grief-stricken', ["devotion", "dec"]), ` that you have killed ${getPronouns(target).his} best source of comfort and companionship in a life of bondage.`);

				relationsDiv.appendChild(subDiv);

				target.devotion -= target.relationship * 10;
			}
		}

		if (isWife) {
			const subDiv = document.createElement("div");

			subDiv.append(`Killing one of your slave wives is `, App.UI.DOM.makeElement("span", 'socially unacceptable.', ["reputation", "dec"]), ` In addition, you other devoted slaves are `, App.UI.DOM.makeElement("span", 'worried', ["trust", "dec"]), ` that you might not respect their status.`);

			relationsDiv.appendChild(subDiv);

			repX(-200, "event", slave);
		}

		if (rival) {
			const subDiv = document.createElement("div");

			rival = getSlave(rival);

			subDiv.append(`${slave.slaveName}'s rival, ${rival.slaveName}, is `, App.UI.DOM.makeElement("span", 'pleased', ["devotion", "inc"]), ` that ${getPronouns(rival).he} won't have to see ${him} anymore.`);

			relationsDiv.appendChild(subDiv);

			rival.devotion += rival.rivalry * 5;
		}

		return relationsDiv;
	}

	function plannedFight() {
		const plannedFightsDiv = document.createElement("div");

		plannedFightsDiv.append(`${!slave.fuckdoll && slave.fetish !== "mindbroken" ? `You abruptly cut ${his} begging short once you` : `You change your mind as you suddenly`} realize ${getSlave(V.pit.slaveFightingBodyguard).slaveName} is already fighting your bodyguard ${S.Bodyguard.slaveName} for ${his} life this week.`);

		App.UI.DOM.appendNewElement("div", plannedFightsDiv, App.UI.DOM.passageLink(`Cancel the fight`, V.returnTo, () => {
			V.pit.slaveFightingBodyguard = null;
		}), ["kill-slave-cancel"]);

		return plannedFightsDiv;
	}
};
