/**
 * @param {string} category
 * @param {string} title
 * @returns {string}
 */
globalThis.budgetLine = function(category, title) {
	let income;
	let expenses;

	if (passage() === "Rep Budget") {
		income = "lastWeeksRepIncome";
		expenses = "lastWeeksRepExpenses";

		if (V[income][category] || V[expenses][category] || V.showAllEntries.repBudget) {
			return `<tr>\
				<td>${title}</td>\
				<td>${repFormat(V[income][category])}</td>\
				<td>${repFormat(V[expenses][category])}</td>\
				<td>${repFormat(V[income][category] + V[expenses][category])}</td>\
				</tr>`;
		}
	} else if (passage() === "Costs Budget") {
		income = "lastWeeksCashIncome";
		expenses = "lastWeeksCashExpenses";

		if (V[income][category] || V[expenses][category] || V.showAllEntries.costsBudget) {
			return `<tr>\
				<td>${title}</td>\
				<td>${cashFormatColor(V[income][category])}</td>\
				<td>${cashFormatColor(-Math.abs(V[expenses][category]))}</td>\
				<td>${cashFormatColor(V[income][category] + V[expenses][category])}</td>\
				</tr>`;
		}
	}
	return ``;
};
